datablock AudioProfile(Tool1EquipSound)
{
   filename    = "./Sounds/Tool1Equip.wav";
   description = AudioClose3d;
   preload = true;
};
AddDamageType("FishingPole",   '<color:00FF00>Hooked<color:FFFFFF> %1',    '%2 <color:00FF00>Hooked %1',0.75,1);
datablock ProjectileData(FishingPoleprojectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 0.5;
   directDamageType  = $DamageType::FishingPole;

   explosion           = FishingPoleExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 10;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "1 1 1";

   uiName = "Fishing Pole";
};

datablock ItemData(FishingPoleItem)
{
	category = "Weapon";
	className = "Weapon";
	shapeFile = "./Models/ItemFishingPole.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "Fishing Pole";
	iconName = "./icon_FishingPole";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";
	image = DrawFishingPoleImage;
	canDrop = true;
};

datablock ShapeBaseImageData(DrawFishingPoleImage)
{
   shapeFile = "./Models/FishingPole.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0 0 -2.0";
   correctMuzzleVector = false;
   className = "WeaponImage";
   item = FishingPoleItem;
   ammo = " ";
   projectile = FishingPoleProjectile;
   projectileType = Projectile;

   melee = true;
   doRetraction = false;
   armReady = true;
   doColorShift = false;
   colorShiftColor = FishingPoleItem.colorShiftColor;

	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 1.5;
	stateSequence[0]			  = "Draw";
	stateTransitionOnTimeout[0]     = "Ready";
	stateSound[0]			  = Tool1EquipSound;

	stateName[1]                    	= "Ready";
	stateScript[1]     = "onSetup";
};

datablock ShapeBaseImageData(FishingPoleImage)
{
   shapeFile = "./Models/FishingPole.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0 0 -2.0";
   correctMuzzleVector = false;
   className = "WeaponImage";
   item = FishingPoleItem;
   ammo = " ";
   projectile = FishingPoleProjectile;
   projectileType = Projectile;

   melee = true;
   doRetraction = false;
   armReady = true;
   doColorShift = false;
   colorShiftColor = FishingPoleItem.colorShiftColor;

	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.001;
	stateSequence[0]		= "Restore";
	stateTransitionOnTimeout[0]	= "Ready";
	stateScript[0]			= "onHide";
	
	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;
	
	stateName[2]                    = "Charge";
	stateScript[2]			= "onPreFire";
	stateTransitionOnTimeout[2]	= "Armed";
	stateTimeoutValue[2]            = 1.0;
	stateSequence[2]		= "Potential";
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";
	stateAllowImageChange[2]        = false;
	
	stateName[3]			= "AbortCharge";
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 1.0;
	stateSequence[3]		= "Draw";
	stateWaitForTimeout[3]		= true;
	stateAllowImageChange[3]	= false;
	
	stateName[4]			= "Armed";
	stateTransitionOnTimeout[4]	= "Strain";
	stateTimeoutValue[4]		= 0.1;
	stateWaitForTimeout[4]		= false;
	stateTransitionOnTriggerUp[4]	= "Fire";
	stateAllowImageChange[4]	= false;
	
	stateName[5]			= "Strain";
	stateTransitionOnTimeout[5]	= "Strain";
	stateTimeoutValue[5]		= 0.1;
	stateTransitionOnTriggerUp[5]	= "Fire";
	stateAllowImageChange[5]	= false;
	
	stateName[6]			= "Fire";
	stateTransitionOnTimeout[6]	= "Prep";
	stateTimeoutValue[6]		= 1.0;
	stateFire[6]			= true;
	stateSequence[6]		= "Throw";
	stateScript[6]			= "onFire";
	stateWaitForTimeout[6]		= true;
	stateAllowImageChange[6]	= false;
	stateSound[6]			= SwingLarge1Sound;

	stateName[7]			= "Prep";
	stateTransitionOnTimeout[7]	= "Ready";
	stateTimeoutValue[7]		= 0.5;
	stateSequence[7]		= "Restore";
	stateWaitForTimeout[7]		= true;
	stateAllowImageChange[7]	= false;

};

datablock ShapeBaseImageData(FishingPoleBackImage)
{
  shapeFile = "./Models/ItemFishingPole.dts";
  emap = true;
  mountPoint = $BackSlot;
  offset = "0.35 -0.35 0.7";
  eyeOffset = "0 0 10";
  rotation = eulerToMatrix("-200 0 270");
  armReady = false;
  doColorShift = false;
};

function FishingPoleImage::onHide(%this,%obj,%slot)
{
		%obj.hideNode("RHand");
		%obj.hideNode("RHook");
		%obj.hideNode("LHand");
		%obj.hideNode("LHook");
}

function DrawFishingPoleImage::onSetup(%this,%obj,%slot)
{
	%obj.mountImage(FishingPoleImage, 0, 0, 0);
}

function FishingPoleImage::onPreFire(%this,%obj,%slot)
{
	%obj.bowChargeTime = getSimTime();
}

function FishingPoleImage::onFire(%this,%obj,%slot)
{
   	%raycastWeaponRange = 5;
   	%raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   					$TypeMasks::PlayerObjectType |	//AI/Players
   					$TypeMasks::StaticObjectType |	//Static Shapes
   					$TypeMasks::TerrainObjectType |	//Terrain
   					$TypeMasks::VehicleObjectType;	//Vehicles
   	%raycastWeaponPierceTargets = "";
   	%raycastExplosionProjectile = FishingPoleProjectile;				//Gun cannot pierce
   	%raycastExplosionPlayerSound = PHitSound;
   	//%raycastExplosionBrickSound = WHitSound;
   	%raycastDirectDamage = 0.5;
   	%raycastDirectDamageType = $DamageType::FishingPole;
	%raycastFromMuzzle	= false;

	%projectile = FishingPoleprojectile;
	%spread = 0.0000;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function DrawFishingPoleImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.playThread(0, armreadyboth);
  	if(%obj.getMountedImage(1))
	{
		%obj.unMountImage(1);
		%obj.hideNode("RHand");
		%obj.hideNode("RHook");
		%obj.hideNode("LHand");
		%obj.hideNode("LHook");
	}
}

function DrawFishingPoleImage::onUnMount(%this, %obj, %slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.playThread(0, root);
  	%obj.unMountImage(1);
  	%obj.mountImage(FishingPoleBackImage,1);
	%obj.unHideNode("ALL");
	if(isObject(%obj.client))
	{
		%obj.client.applyBodyParts();
		%obj.client.applyBodyColors();
	}
	else
	{
		applyDefaultCharacterPrefs(%obj);
	}
}

function FishingPoleImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.playThread(0, armreadyboth);
  	if(%obj.getMountedImage(1))
	{
		%obj.unMountImage(1);
		%obj.hideNode("RHand");
		%obj.hideNode("RHook");
		%obj.hideNode("LHand");
		%obj.hideNode("LHook");
	}
}

function FishingPoleImage::onUnMount(%this, %obj, %slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.playThread(0, root);
  	%obj.unMountImage(1);
  	%obj.mountImage(FishingPoleBackImage,1);
	%obj.unHideNode("ALL");
	if(isObject(%obj.client))
	{
		%obj.client.applyBodyParts();
		%obj.client.applyBodyColors();
	}
	else
	{
		applyDefaultCharacterPrefs(%obj);
	}
}

package FishingPoleDropPackage
{
  function servercmdDropTool(%this,%slot)
  {
	parent::servercmdDropTool(%this,%slot);
	%this.player.schedule(5,unmountimage,1);
	%this.player.schedule(5,unmountimage,0);
  }
};
activatepackage(FishingPoleDropPackage);
function FishingPoleprojectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)

{

	parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);

	if(%col.getClassName() $= "fxDTSBrick")

	{

		$InputTarget_["Self"] = %col;

		$InputTarget_["Player"] = %obj.client.player;

		$InputTarget_["Client"] = %obj.client;

		if($Server::LAN)

		{

			$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj.client);

		}

		else

		{

			if(getMiniGameFromObject(%col) == getMiniGameFromObject(%obj.client))

			{

				$InputTarget_["MiniGame"] = getMiniGameFromObject(%col);

			}

			else

			{

				$InputTarget_["MiniGame"] = 0;

			}

		}

		%col.processInputEvent(OnFishingPoleHit,%obj.client);

	}

}
//Sounds
datablock AudioProfile(PHitSound)
{
   filename    = "./Sounds/BBHP.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(PHit2Sound)
{
   filename    = "./Sounds/BBHP2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(WHitSound)
{
   filename    = "./Sounds/BBHW.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(WHitTSound)
{
   filename    = "./Sounds/BBHW2.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(SwingLarge1Sound)
{
   filename    = "./Sounds/SwingLarge1.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(Tool1EquipSound)
{
   filename    = "./Sounds/Tool1Equip.wav";
   description = AudioClose3d;
   preload = true;
};