AddDamageType("Fist",   '<color:00FF00>K Oed<color:FFFFFF> %1',    '%2 <color:00FF00>K Oed %1',0.75,1);
datablock ProjectileData(Fistprojectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 5;
   directDamageType  = $DamageType::Fist;

   explosion           = FistExplosion;

   muzzleVelocity      = 10;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "1 1 1";

   uiName = "Fist";
};
datablock ItemData(FistItem)
{
	category = "Weapon";
	className = "Weapon";
	shapeFile = "./Models/Fist.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "";
	iconName = "./Icon_Fist";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";
	image = DrawFistImage;
	canDrop = true;
};

datablock ShapeBaseImageData(DrawFistImage)
{
   shapeFile = "./Models/Fist.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0 0 -2.0";
   correctMuzzleVector = false;
   className = "WeaponImage";
   item = FistItem;
   ammo = " ";
   projectile = FistProjectile;
   projectileType = Projectile;

   Right = true;
   doRetraction = false;
   armReady = true;
   doColorShift = false;
   colorShiftColor = FistItem.colorShiftColor;

	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.3;
	stateSequence[0]			  = "Draw";
	stateTransitionOnTimeout[0]     = "Ready";

	stateName[1]                    	= "Ready";
	stateScript[1]     = "onSetup";
};

datablock ShapeBaseImageData(FistImage)
{
   shapeFile = "./Models/Fist.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0 0 -2.0";
   correctMuzzleVector = false;
   className = "WeaponImage";
   item = FistItem;
   ammo = " ";
   projectile = FistProjectile;
   projectileType = Projectile;

   Right = true;
   doRetraction = false;
   armReady = true;
   doColorShift = false;
   colorShiftColor = FistItem.colorShiftColor;

   raycastWeaponRange = 2;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType;	//Terrain
   raycastExplosionProjectile = FistProjectile;
   raycastExplosionBrickSound = WoodHit1Sound;
   raycastExplosionPlayerSound = PHitSound;
   raycastDirectDamage = 5;
   raycastDirectDamageType = $DamageType::Fist;

	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.0001;
	stateScript[0]			= "onHide";
	stateSequence[0]		= "Left2";
	stateTransitionOnTimeout[0]	= "Ready";
	
	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Swing";
	stateAllowImageChange[1]	= true;
	stateTimeoutValue[1]            = 0.001;
	
	stateName[2]                    = "Swing";
	stateScript[2]			= "onPreFire";
	stateTransitionOnTimeout[2]	= "Swing2";
	stateTimeoutValue[2]            = 0.2;
	stateSequence[2]		= "Left1";
	stateWaitForTimeout[2]		= true;
	stateAllowImageChange[2]        = false;
	
	stateName[3]                    = "Swing2";
	stateTransitionOnTimeout[3]	= "Activate";
	stateTimeoutValue[3]            = 0.3;
	stateSequence[3]		= "Left2";
	stateFire[3]			= true;
	stateScript[3]			= "onFire";
	stateWaitForTimeout[3]		= true;
	stateAllowImageChange[3]        = false;
};
function FistImage::onHide(%this,%obj,%slot)
{
		%obj.hideNode("RHand");
		%obj.hideNode("RHook");
		%obj.hideNode("LHand");
		%obj.hideNode("LHook");
}

function DrawFistImage::onSetup(%this,%obj,%slot)
{
	%obj.mountImage(FistImage, 0, 0, 0);
}

function FistImage::onPreFire(%this,%obj,%slot)
{
	%obj.bowChargeTime = getSimTime();
}

//function FistImage::onFire(%this,%obj,%slot)
//{
//}
function DrawFistImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.playThread(0, armreadyboth);
  	if(%obj.getMountedImage(1))
	{
		%obj.hideNode("RHand");
		%obj.hideNode("RHook");
		%obj.hideNode("LHand");
		%obj.hideNode("LHook");
	}
}
function DrawFistImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.playThread(0, armreadyboth);
  	if(%obj.getMountedImage(1))
	{
		%obj.hideNode("RHand");
		%obj.hideNode("RHook");
		%obj.hideNode("LHand");
		%obj.hideNode("LHook");
	}
}

function DrawFistImage::onUnMount(%this, %obj, %slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.playThread(0, root);
	%obj.unHideNode("ALL");
	if(isObject(%obj.client))
	{
		%obj.client.applyBodyParts();
		%obj.client.applyBodyColors();
	}
	else
	{
		applyDefaultCharacterPrefs(%obj);
	}
}

function FistImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.playThread(0, armreadyboth);
  	if(%obj.getMountedImage(1))
	{
		%obj.unMountImage(1);
		%obj.hideNode("RHand");
		%obj.hideNode("RHook");
		%obj.hideNode("LHand");
		%obj.hideNode("LHook");
	}
}

function FistImage::onUnMount(%this, %obj, %slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.playThread(0, root);
	%obj.unHideNode("ALL");
	if(isObject(%obj.client))
	{
		%obj.client.applyBodyParts();
		%obj.client.applyBodyColors();
	}
	else
	{
		applyDefaultCharacterPrefs(%obj);
	}
}

package FistRight
{
	function armor::onTrigger(%this, %obj, %triggerNum, %val)
	{
		%client = %obj.client;
		if(%triggerNum == 4 && %obj.isImageMounted(FistImage) && %val)
		{
			%obj.mountImage(FistRightImage, 0, 0, 0);
		}
		Parent::onTrigger(%this, %obj, %triggerNum, %val);
	}
};
activatePackage(FistRight);

datablock ShapeBaseImageData(FistRightImage)
{
   shapeFile = "./Models/Fist.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   rotation = eulerToMatrix("0 0 0");
   eyeOffset = "0 0 -2.0";
   correctMuzzleVector = false;
   className = "WeaponImage";
   item = FistItem;
   ammo = " ";
   projectile = FistProjectile;
   projectileType = Projectile;
   Right = true;
   canDrop = true;
   doRetraction = false;
   armReady = true;
   doColorShift = false;
   
   raycastWeaponRange = 2;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType;	//Terrain
   raycastExplosionProjectile = FistProjectile;
   raycastExplosionBrickSound = WoodHit1Sound;
   raycastExplosionPlayerSound = PHitSound;
   raycastDirectDamage = 5;
   raycastDirectDamageType = $DamageType::Fist;
   
	stateName[0]			= "Equip";
	stateTimeoutValue[0]		= 0.0001;
	stateSequence[0]		= "Right2";
	stateTransitionOnTimeout[0]	= "Swing";
	
	stateName[1]			= "Ready";
	stateAllowImageChange[1]	= true;
	stateTimeoutValue[1]            = 2.0;
	stateWaitForTimeout[1]		= false;
	stateSequence[1]		= "Idle";
	stateTransitionOnTimeout[1]	= "Ready";
	
	stateName[2]                    = "Swing";
	stateScript[2]			= "onPreFire";
	stateTransitionOnTimeout[2]	= "Swing2";
	stateTimeoutValue[2]            = 0.2;
	stateSequence[2]		= "Right1";
	stateWaitForTimeout[2]		= true;
	stateAllowImageChange[2]        = false;
	
	stateName[3]                    = "Swing2";
	stateTransitionOnTimeout[3]	= "UnEquip";
	stateTimeoutValue[3]            = 0.3;
	stateSequence[3]		= "Right2";
	stateFire[3]			= true;
	stateScript[3]			= "onFire";
	stateWaitForTimeout[3]		= true;
	stateAllowImageChange[3]        = false;

	stateName[4]			= "UnEquip";
	stateTimeoutValue[4]		= 0.001;
	stateScript[4]			= "onUnEquip";
};
function FistRightImage::onUnEquip(%this, %obj, %slot)
{
	%obj.unMountImage(0);
	%obj.MountImage(FistImage, 0, 0, 0);
}


function FistRightImage::onMount(%this, %obj, %slot)
{		
	Parent::onMount(%this,%obj,%slot);
	%obj.playThread(1, armreadyboth);
  	if(%obj.getMountedImage(1))
	{
		%obj.unMountImage(1);
		%obj.hideNode("RHand");
		%obj.hideNode("RHook");
		%obj.hideNode("LHand");
		%obj.hideNode("LHook");
	}
}


function FistRightImage::onUnMount(%this, %obj, %slot)
{	
	Parent::onUnMount(%this,%obj,%slot);
	%obj.playThread(0, root);
	%obj.unHideNode("ALL");
	if(isObject(%obj.client))
	{
		%obj.client.applyBodyParts();
		%obj.client.applyBodyColors();
	}
	else
	{
		applyDefaultCharacterPrefs(%obj);
	}
}
function FistProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)

{

	parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);

	if(%col.getClassName() $= "fxDTSBrick")

	{

		$InputTarget_["Self"] = %col;

		$InputTarget_["Player"] = %obj.client.player;

		$InputTarget_["Client"] = %obj.client;

		if($Server::LAN)

		{

			$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj.client);

		}

		else

		{

			if(getMiniGameFromObject(%col) == getMiniGameFromObject(%obj.client))

			{

				$InputTarget_["MiniGame"] = getMiniGameFromObject(%col);

			}

			else

			{

				$InputTarget_["MiniGame"] = 0;

			}

		}

		%col.processInputEvent(OnFistHit,%obj.client);

	}

}
package Fist
{
	function serverCmdFist(%client)
	{
		%obj = %client.player;
		if(%obj.lastKnife - getSimTime() < 1000)
		{
	 		%obj.oldItem = %obj.getMountedImage(0);
	 		%obj.mountImage(FistImage, 0);
		}
		else if(%obj.isImageMounted(FistImage) && %obj.lastKnife - getSimTime() < 1000)
		{
			%obj.oldItem = %obj.getMountedImage(0);
		}
		%obj.lastKnife = getSimTime();
		parent::serverCmdFist(%client);
	}
};   
ActivatePackage(Fist);