   datablock AudioProfile(CPBowPickupSound)
   {
      filename = "./Sounds/ArrowPickup.wav";
      description = AudioClosest3d;
      preload = false;
   };
   datablock AudioProfile(CPBowPackPickupSound)
   {
      filename = "./Sounds/ArrowPackPickup.wav";
      description = AudioClosest3d;
      preload = false;
   };

/////////////////////////////////

datablock ItemData(CPBowstaticItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	shapeFile = "./Models/CpBowArrow.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	rotate = false;
	uiName = "Ammo(RP) Arrow(Reg)";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";
	canDrop = true;
	ammocount = 1;
};

function CPBowstaticItem::onAdd(%this, %obj)
{
	%obj.rotate = false;
	%obj.setShapeName(%obj.ammocount);
	Parent::onAdd(%this, %obj);
}

/////////////////////////////////

datablock ItemData(CPBow10PackstaticItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	shapeFile = "./Models/CpBowArrowPack.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	rotate = false;
	uiName = "Ammo(RP) Arrow(Reg)x10";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";
	canDrop = true;
	ammocount = 10;
};

function CPBow10PackstaticItem::onAdd(%this, %obj)
{
	%obj.rotate = false;
	%obj.setShapeName(%obj.ammocount);
	Parent::onAdd(%this, %obj);
}
/////////////////////////////////
datablock ItemData(CPDartstaticItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	shapeFile = "./Models/DumThrDart.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	rotate = false;
	uiName = "Ammo(RP) Dart(Reg)";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";
	canDrop = true;
	ammocount = 1;
};

function CPDartstaticItem::onAdd(%this, %obj)
{
	%obj.rotate = false;
	%obj.setShapeName(%obj.ammocount);
	Parent::onAdd(%this, %obj);
}

/////////////////////////////////

datablock ItemData(CPDart5PackstaticItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	shapeFile = "./Models/ThrDart5Pack.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	rotate = false;
	uiName = "Ammo(RP) Dart(Reg)x5";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";
	canDrop = true;
	ammocount = 5;
};

function CPDart5PackstaticItem::onAdd(%this, %obj)
{
	%obj.rotate = false;
	%obj.setShapeName(%obj.ammocount);
	Parent::onAdd(%this, %obj);
}
/////////////////////////////////

datablock ItemData(RockstaticItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	shapeFile = "./Models/RockBag50.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	rotate = false;
	uiName = "Ammo(50) RockBag";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";
	canDrop = true;
	ammocount = 50;
};

function RockstaticItem::onAdd(%this, %obj)
{
	%obj.rotate = false;
	%obj.setShapeName(%obj.ammocount);
	Parent::onAdd(%this, %obj);
}
/////////////////////////////////
/////////////////////////////////

datablock ItemData(JavlinstaticItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	shapeFile = "./Models/Javlinproj.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	rotate = true;
	uiName = "Ammo(1) Javlin";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";
	canDrop = true;
	ammocount = 1;
};

function JavlinstaticItem::onAdd(%this, %obj)
{
	%obj.rotate = false;
	%obj.setShapeName(%obj.ammocount);
	Parent::onAdd(%this, %obj);
}
/////////////////////////////////
package AmmoStaticRPPackage
{
	function Armor::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f)
	{
		if(%col.dataBlock $= "CPBowstaticItem" && %col.canPickup && %obj.getDamagePercent() < 1.0)
		{
		%obj.client.quantity["CpArr"] += %col.getdatablock().ammocount;
		serverPlay3D(CPBowPickupSound,%obj.getPosition());

		if(isObject(%col.spawnbrick))
			{
			%col.fadeOut();
			%col.schedule(%col.spawnbrick.itemrespawntime, "fadeIn");
			}else{
			%col.schedule(3, delete);
			}
		%this.onPickup(%obj, %player);
		return;
	}
	Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
	}
};
activatePackage(AmmoStaticRPPackage);
/////////////////////////////////
package AmmoStaticRP2Package
{
	function Armor::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f)
	{
		if(%col.dataBlock $= "CPBow10PackstaticItem" && %col.canPickup && %obj.getDamagePercent() < 1.0)
		{
		%obj.client.quantity["CpArr"] += %col.getdatablock().ammocount;
		%obj.client.quantity["FireArr"] += 10;
		%obj.client.quantity["IceArr"] += 10;
		%obj.client.quantity["ExpArr"] += 10;
		serverPlay3D(CPBowPackPickupSound,%obj.getPosition());

		if(isObject(%col.spawnbrick))
			{
			%col.fadeOut();
			%col.schedule(%col.spawnbrick.itemrespawntime, "fadeIn");
			}else{
			%col.schedule(3, delete);
			}
		%this.onPickup(%obj, %player);
		return;
	}
	Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
	}
};
activatePackage(AmmoStaticRP2Package);
/////////////////////////////////
package AmmoStaticRP3Package
{
	function Armor::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f)
	{
		if(%col.dataBlock $= "RockstaticItem" && %col.canPickup && %obj.getDamagePercent() < 1.0)
		{
		%obj.client.quantity["Rocks"] += %col.getdatablock().ammocount;
		serverPlay3D(CPBowPackPickupSound,%obj.getPosition());

		if(isObject(%col.spawnbrick))
			{
			%col.fadeOut();
			%col.schedule(%col.spawnbrick.itemrespawntime, "fadeIn");
			}else{
			%col.schedule(3, delete);
			}
		%this.onPickup(%obj, %player);
		return;
	}
	Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
	}
};
activatePackage(AmmoStaticRP3Package);
/////////////////////////////////
package AmmoStaticRP4Package
{
	function Armor::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f)
	{
		if(%col.dataBlock $= "JavlinstaticItem" && %col.canPickup && %obj.getDamagePercent() < 1.0)
		{
		%obj.client.quantity["Javlin"] += %col.getdatablock().ammocount;
		serverPlay3D(CPBowPackPickupSound,%obj.getPosition());

		if(isObject(%col.spawnbrick))
			{
			%col.fadeOut();
			%col.schedule(%col.spawnbrick.itemrespawntime, "fadeIn");
			}else{
			%col.schedule(3, delete);
			}
		%this.onPickup(%obj, %player);
		return;
		}
	Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
	}
};
activatePackage(AmmoStaticRP4Package);
/////////////////////////////////
package AmmoStaticRP5Package
{
	function Armor::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f)
	{
		if(%col.dataBlock $= "CPDartstaticItem" && %col.canPickup && %obj.getDamagePercent() < 1.0)
		{
		%obj.client.quantity["Darts"] += %col.getdatablock().ammocount;
		serverPlay3D(CPBowPackPickupSound,%obj.getPosition());

		if(isObject(%col.spawnbrick))
			{
			%col.fadeOut();
			%col.schedule(%col.spawnbrick.itemrespawntime, "fadeIn");
			}else{
			%col.schedule(3, delete);
			}
		%this.onPickup(%obj, %player);
		return;
		}
	Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
	}
};
activatePackage(AmmoStaticRP5Package);
/////////////////////////////////
package AmmoStaticRP6Package
{
	function Armor::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f)
	{
		if(%col.dataBlock $= "CPDart5PackstaticItem" && %col.canPickup && %obj.getDamagePercent() < 1.0)
		{
		%obj.client.quantity["Darts"] += %col.getdatablock().ammocount;
		serverPlay3D(CPBowPackPickupSound,%obj.getPosition());

		if(isObject(%col.spawnbrick))
			{
			%col.fadeOut();
			%col.schedule(%col.spawnbrick.itemrespawntime, "fadeIn");
			}else{
			%col.schedule(3, delete);
			}
		%this.onPickup(%obj, %player);
		return;
		}
	Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
	}
};
activatePackage(AmmoStaticRP6Package);