datablock AudioProfile(SlingShotPullSound)
{
   filename    = "./Sounds/SlingShotPull.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(SlingShotFireSound)
{
   filename    = "./Sounds/SlingShotFire.wav";
   description = AudioClose3d;
   preload = true;
};
AddDamageType("SlingShot",   '<color:00FF00>Ranged<color:FFFFFF> %1',    '%2 <color:00FF00>Ranged %1',0.75,1);
datablock ProjectileData(SlingShotRegProjectile)
{
	uiName="";
	projectileShapeName="./Models/RockProj.dts";
   	directDamage        = 5;
   	directDamageType    = $DamageType::SlingShot;
   	radiusDamage        = 0;
   	damageRadius        = 0;
   	radiusDamageType    = $DamageType::SlingShot;
	brickExplosionRadius=0;
	brickExplosionImpact=false;
	brickExplosionForce=30;
	brickExplosionMaxVolume=1;
	brickExplosionMaxVolumeFloating=2;
	impactImpulse=60;
	muzzleVelocity=50;
	verInheritFactor=1;
   	stickExplosion        = arrowStickExplosion;
   	explodeOnPlayerImpact = true;
   	explodeOnDeath        = true;  
	lifetime=30000;
	fadeDelay=29900;
   	armingDelay= 0;
	bounceElasticity=0.2;
	bounceFriction=0.2;
	isBallistic=true;
	gravityMod=1.0;
	sound=CpBowWhizSound;

};

datablock ItemData(SlingShotItem)
{
	uiName="SlingShot";
	iconName="./icon_SlingShot";
	image=SlingShotimage;
	category=Weapon;
	className=Weapon;
	shapeFile="./Models/DumSlingShot.dts";
	mass=1;
	density=0.2;
	elasticity=0;
	friction=0.6;
	emap=true;
	doColorShift=false;
	colorShiftColor="1 1 1 1";
	canDrop=true;
	maxAmmo = 1;
	canReload = 1;
};

datablock ShapeBaseImageData(SideBagImage)
{
   shapeFile = "./Models/SideBag.dts";
   emap = false;

   mountPoint = 7;
   rotation = "0 0 0 0";
   offset = "-0.005 -0.02 0.18";

   stateName[0]            = "Ready";
   stateTransitionOnTimeout[0]      = "Ready";
   stateTimeoutValue[0]         = 1;
   
   armReady = true;
};

datablock shapeBaseimageData(SlingShotimage)
{
	shapeFile="./Models/SlingShot.dts";
	emap=true;
	correctMuzzleVector=true;
	className="Weaponimage";
	item=SlingShotItem;
	ammo="";
	projectile=SlingShotRegProjectile;
	projectileType=Projectile;
	melee=true;
	doReaction=false;
	armReady=true;
	doColorShift=false;
	colorShiftColor="1 1 1 1";
   	mountPoint = 0;
   	offset = "0.08 0 0";
   	eyeOffset = "0.05 0 -2.15";
   	rotation = eulerToMatrix( "0 0 0" );
	
	stateName[0]                    = "Activate";
	stateSequence[0]		= "Draw";
	stateTimeoutValue[0]            = 0.5;
	stateTransitionOnTimeout[0]     = "LoadCheckA";
	stateScript[0]				= "onHide";

	stateName[1]                    = "Ready";
	stateTransitionOnNoAmmo[1]	= "ClipOut";
	stateTransitionOnTriggerDown[1] = "Pull";
	stateAllowImageChange[1]        = true;

	stateName[2]                    = "Fire";
	stateTimeoutValue[2]            = 0.4;
	stateTransitionOnTimeout[2]     = "Prep";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateSequence[2]		= "Fire";
	stateWaitForTimeout[2]		= true;
	stateSound[2]			= SlingShotFireSound;
	stateEjectShell[2]              = false;

	stateName[3] 			= "Prep";
	stateAllowImageChange[3]        = false;
	stateTimeoutValue[3]	= 0.01;
	stateTransitionOnTimeout[3]	= "FireLoadCheckA";

	stateName[4]			= "Wait";
	stateTimeoutValue[4]		= 0.01;
	stateAllowImageChange[4]        = true;
	stateScript[4]                  = "";
	stateTransitionOnTriggerUp[4] = "Delay";
	
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "ReadyWeap3";
	stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.001;
	stateScript[7]				= "";
	stateTransitionOnTimeout[7]		= "ClipOut";

	stateName[8]				= "ClipOut";
	stateTimeoutValue[8]			= 0.001;
	stateScript[8]				= "onReloadStart";
	stateAllowImageChange[8]        = true;
	stateTransitionOnTimeout[8]		= "ClipIn";
	
	stateName[9]				= "ClipIn";
	stateTimeoutValue[9]			= 0.001;
	stateAllowImageChange[9]        = true;
	stateSequence[9]			= "Reload";
	stateTransitionOnTimeout[9]		= "reloadFinish";
	
	stateName[10]				= "reloadFinish";
	stateTimeoutValue[10]			= 0.001;
	stateAllowImageChange[10]        = false;
	stateScript[10]				= "onReloaded";
	stateTransitionOnTimeout[10]		= "Ready";
	
	stateName[11]				= "FireLoadCheckA";
	stateScript[11]				= "onLoadCheck";
	stateTimeoutValue[11]			= 0.01;
	stateTransitionOnTimeout[11]		= "FireLoadCheckB";
	
	stateName[12]				= "FireLoadCheckB";
	stateTransitionOnAmmo[12]		= "Wait";
	stateTransitionOnNoAmmo[12]		= "ReloadWait";
	
	stateName[13]				= "Delay";
	stateTransitionOnTimeout[13]		= "Ready";
	stateSequence[13]		= "Draw";
	stateTimeoutValue[13]            = 0.5;
	
	stateName[14]				= "ReadyWeap3";
	stateTransitionOnTimeout[14]		= "Ready";

	stateName[15] 			= "Pull";
	stateAllowImageChange[15]        = false;
	stateTimeoutValue[15]	= 0.5;
	stateTransitionOnTriggerUp[15] = "Abort";
	stateSequence[15]		= "Set";
	stateTransitionOnTimeout[15]	= "Set";
	stateSound[15]				= SlingShotPullSound;
	stateWaitForTimeout[15]	= false;

	stateName[16] 			= "Set";
	stateTransitionOnTriggerUp[16] = "Fire";
	stateAllowImageChange[16]	= false;
	stateTimeoutValue[16]            = 3.0;
	stateWaitForTimeout[16]		= false;

	stateName[17] 			= "Abort";
	stateSequence[17]		= "Prep";
	stateTransitionOnTimeout[17]	= "Ready";
	stateSequence[17]		= "fail";
	stateWaitForTimeout[17]		= true;
	stateAllowImageChange[17]	= false;
	stateTimeoutValue[17]		= 0.4;
};	

datablock ShapeBaseImageData(SlingShotBackImage)
{
  shapeFile = "./Models/DumSlingShot.dts";
  emap = true;
  mountPoint = $BackSlot;
  offset = "0.6 0 -0.9";
  eyeOffset = "0 0 10";
  rotation = eulerToMatrix("-90 90 360");
  armReady = false;
  doColorShift = false;
};

function SlingShotImage::onHide(%this,%obj,%slot)
{
		%obj.hideNode("RHand");
		%obj.hideNode("RHook");
		%obj.hideNode("LHand");
		%obj.hideNode("LHook");
}

function SlingShotimage::onReloaded(%this,%obj,%slot)
{
    	if(%obj.client.quantity["Rocks"] >= 1)
	{
        	if(%obj.client.quantity["Rocks"] > 1)
		{
			%obj.client.quantity["Rocks"] -= %obj.AmmoSpent[%obj.currTool];
			%obj.toolAmmo[%obj.currTool]=%this.item.maxAmmo;
			%obj.AmmoSpent[%obj.currTool] = 0;
			%obj.setImageAmmo(%slot,1);
        		commandToClient(%obj.client,'bottomPrint',"<just:right><color:ffffff>Rocks: \c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["Rocks"] @ "", 1, 2, 3, 4); 
			return;
		}
        	if(%obj.client.quantity["Rocks"] <= 1)
		{
			%obj.client.exchangebullets = %obj.client.quantity["Rocks"];
			%obj.toolAmmo[%obj.currTool] = %obj.client.exchangebullets;
			%obj.setImageAmmo(%slot,1);
			%obj.client.quantity["Rocks"] = 0;
        		commandToClient(%obj.client,'bottomPrint',"<just:right><color:ffffff>Rocks: \c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["Rocks"] @ "", 1, 2, 3, 4); 
			return;
		}
	}
}

function SlingShotimage::onMount(%this,%obj,%slot)	
{
	Parent::onMount(%this,%obj,%slot);
	%obj.mountImage(SideBagImage,3);
	%obj.playThread(0, armreadyboth);
  	if(%obj.getMountedImage(1))
	{
		%obj.unMountImage(1);
		%obj.hideNode("RHand");
		%obj.hideNode("RHook");
		%obj.hideNode("LHand");
		%obj.hideNode("LHook");
	}
        commandToClient(%obj.client,'bottomPrint',"<just:right><color:ffffff>Rocks: \c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["Rocks"] @ "", 1, 2, 3, 4); 

}

function SlingShotimage::onUnMount(%this,%obj,%slot)
{
	parent::onUnMount(%this,%obj,%slot);
	%obj.playThread(0, root);
  	%obj.unMountImage(1);
  	%obj.unMountImage(3);
  	%obj.mountImage(SlingShotBackImage,1);
	%obj.unhideNode("ALL");
	if(isObject(%obj.client))
	{
			%obj.client.applyBodyParts();
			%obj.client.applyBodyColors();
	}
	else
	{
		applyDefaultCharacterPrefs(%obj);
	}
	%obj.client.setControlCameraFov(90);
}
function SlingShotimage::onFire(%this,%obj,%slot,%spread,%shellcount,%recoil)
{
	if(%obj.toolAmmo[%obj.currTool] > 1)
	{
		%obj.toolAmmo[%obj.currTool] = 1;
	}

	if(%obj.toolAmmo[%obj.currTool] > 0 && %obj.isImageMounted(SlingShotImage))
	{
		%projectile = SlingShotRegProjectile;
		%spread = 0.000;
		%shellcount = 1;
		%obj.toolAmmo[%obj.currTool]--;
		%obj.AmmoSpent[%obj.currTool]++;
        	commandToClient(%obj.client,'bottomPrint',"<just:right><color:ffffff>Rocks: \c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["Rocks"] @ "", 1, 2, 3, 4); 
		for(%shell=0; %shell<%shellcount; %shell++)
		{
			%vector = %obj.getMuzzleVector(%slot);
			%objectVelocity = %obj.getVelocity();
			%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
			%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
			%velocity = VectorAdd(%vector1,%vector2);
			%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
			%velocity = MatrixMulVector(%mat, %velocity);
	
			%p = new (%this.projectileType)()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};
			MissionCleanup.add(%p);
		}
		return %p;
	}
    	if(%obj.client.quantity["Rocks"] < 1)
	{
		%obj.client.quantity["Rocks"] = 0;
	}
}

activatePackage(SlingShotDropPackage);
function SlingShotRegProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)

{

	parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);

	if(%col.getClassName() $= "fxDTSBrick")

	{

		$InputTarget_["Self"] = %col;

		$InputTarget_["Player"] = %obj.client.player;

		$InputTarget_["Client"] = %obj.client;

		if($Server::LAN)

		{

			$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj.client);

		}

		else

		{

			if(getMiniGameFromObject(%col) == getMiniGameFromObject(%obj.client))

			{

				$InputTarget_["MiniGame"] = getMiniGameFromObject(%col);

			}

			else

			{

				$InputTarget_["MiniGame"] = 0;

			}

		}

		%col.processInputEvent(OnSlingRockHit,%obj.client);

	}

}