datablock AudioProfile(SwingLarge1Sound)
{
   filename    = "./Sounds/SwingLarge1.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(SwingLarge2Sound)
{
   filename    = "./Sounds/SwingLarge2.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(SwingMedium1Sound)
{
   filename    = "./Sounds/SwingMedium1.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(SwingMedium2Sound)
{
   filename    = "./Sounds/SwingMedium2.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(WoodHit1Sound)
{
   filename    = "./Sounds/WoodHit1.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(Tool1EquipSound)
{
   filename    = "./Sounds/Tool1Equip.wav";
   description = AudioClose3d;
   preload = true;
};
datablock ParticleData(STWoodAxeExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/chunk";
   colors[0]     = "0.7 0.7 0.9 0.9";
   colors[1]     = "0.9 0.9 0.9 0.0";
   sizes[0]      = 0.1;
   sizes[1]      = 0.25;
};

datablock ParticleEmitterData(STWoodAxeExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "STWoodAxeExplosionParticle";
};

datablock ExplosionData(STWoodAxeExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = WHitSound;

   particleEmitter = STWoodAxeExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

};
datablock ParticleEmitterData(STWoodAxeCritExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "STWoodAxeExplosionParticle";
};

datablock ExplosionData(STWoodAxeCritExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = WHitTSound;

   particleEmitter = STWoodAxeExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

};
AddDamageType("STWoodAxe",   '<color:00FF00>Sliced<color:FFFFFF> %1',    '%2 <color:00FF00>Sliced %1',0.75,1);
datablock ProjectileData(STWoodAxeCutprojectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 10;
   directDamageType  = $DamageType::STWoodAxe;

   explosion           = STWoodAxeExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 10;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "1 1 1";

   uiName = "SteelWoodAxeCut";
};
datablock ProjectileData(STWoodAxeLungeprojectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 15;
   directDamageType  = $DamageType::STWoodAxe;

   explosion           = STWoodAxeExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 10;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "1 1 1";

   uiName = "SteelWoodAxeLunge";
};
datablock ProjectileData(STWoodAxeSwingprojectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 15;
   directDamageType  = $DamageType::STWoodAxe;

   explosion           = STWoodAxeExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 10;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "1 1 1";

   uiName = "SteelWoodAxeSwing";
};

datablock ItemData(STWoodAxeItem)
{
	category = "Weapon";
	className = "Weapon";
	shapeFile = "./Models/ItemSTWoodAxe.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "Steel WoodAxe";
	iconName = "./Icon_STWoodAxe";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";
	image = DrawSTWoodAxeImage;
	canDrop = true;
};

datablock ShapeBaseImageData(DrawSTWoodAxeImage)
{
   shapeFile = "./Models/STWoodAxe.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0 0 -2.0";
   correctMuzzleVector = false;
   className = "WeaponImage";
   item = STWoodAxeItem;
   ammo = " ";
   projectile = STWoodAxeProjectile;
   projectileType = Projectile;

   melee = true;
   doRetraction = false;
   armReady = true;
   doColorShift = false;
   colorShiftColor = STWoodAxeItem.colorShiftColor;

	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 1.0;
	stateSequence[0]			  = "Draw";
	stateTransitionOnTimeout[0]     = "Ready";
	stateSound[0]			  = Tool1EquipSound;

	stateName[1]                    	= "Ready";
	stateScript[1]     = "onSetup";
};

datablock ShapeBaseImageData(STWoodAxeImage)
{
   shapeFile = "./Models/STWoodAxe.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0 0 -2.0";
   correctMuzzleVector = false;
   className = "WeaponImage";
   item = STWoodAxeItem;
   ammo = " ";
   projectile = STWoodAxeProjectile;
   projectileType = Projectile;

   melee = true;
   doRetraction = false;
   armReady = true;
   doColorShift = false;
   colorShiftColor = STWoodAxeItem.colorShiftColor;

	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.001;
	stateSequence[0]		= "chop2";
	stateTransitionOnTimeout[0]	= "Ready";
	stateScript[0]		= "onHide";
	
	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;
	
	stateName[2]                    = "Charge";
	stateScript[2]			= "onPreFire";
	stateTransitionOnTimeout[2]	= "Armed";
	stateTimeoutValue[2]            = 0.7;
	stateSequence[2]		= "Potential";
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";
	stateAllowImageChange[2]        = false;
	
	stateName[3]			= "AbortCharge";
	stateTransitionOnTimeout[3]	= "Abortcharge2";
	stateTimeoutValue[3]		= 0.2;
	stateSequence[3]		= "Strike1";
	stateWaitForTimeout[3]		= true;
	stateAllowImageChange[3]	= false;
	stateSound[3]			= SwingMedium1Sound;
	stateAllowImageChange[3]	= false;
	
	stateName[4]			= "Armed";
	stateTransitionOnTimeout[4]	= "Strain";
	stateTimeoutValue[4]		= 0.1;
	stateWaitForTimeout[4]		= false;
	stateTransitionOnTriggerUp[4]	= "Fire";
	stateAllowImageChange[4]	= false;
	
	stateName[5]			= "Strain";
	stateTransitionOnTimeout[5]	= "Strain";
	stateTimeoutValue[5]		= 0.1;
	stateTransitionOnTriggerUp[5]	= "Fire";
	stateAllowImageChange[5]	= false;
	
	stateName[6]			= "Fire";
	stateTransitionOnTimeout[6]	= "Fire2";
	stateTimeoutValue[6]		= 0.2;
	stateSequence[6]		= "Chop1";
	stateWaitForTimeout[6]		= true;
	stateAllowImageChange[6]	= false;
	stateSound[6]			= SwingLarge2Sound;

	stateName[7]			= "AbortCharge2";
	stateTransitionOnTimeout[7]	= "Ready";
	stateTimeoutValue[7]		= 0.6;
	stateFire[7]			= true;
	stateSequence[7]		= "Strike2";
	stateScript[7]			= "onFireCut";
	stateWaitForTimeout[7]		= true;
	stateAllowImageChange[7]	= false;

	stateName[8]			= "Fire2";
	stateTransitionOnTimeout[8]	= "Ready";
	stateTimeoutValue[8]		= 0.8;
	stateFire[8]			= true;
	stateSequence[8]		= "Chop2";
	stateScript[8]			= "onFireLunge";
	stateWaitForTimeout[8]		= true;
	stateAllowImageChange[8]	= false;
};

datablock ShapeBaseImageData(STWoodAxeBackImage)
{
  shapeFile = "./Models/ItemSTWoodAxe.dts";
  emap = true;
  mountPoint = $BackSlot;
  offset = "0.5 0 -0.8";
  eyeOffset = "0 0 10";
  rotation = eulerToMatrix("-180 0 0");
  armReady = false;
  doColorShift = false;
};

function STWoodAxeImage::onHide(%this,%obj,%slot)
{
		%obj.hideNode("RHand");
		%obj.hideNode("RHook");
		%obj.hideNode("LHand");
		%obj.hideNode("LHook");
}

function DrawSTWoodAxeImage::onSetup(%this,%obj,%slot)
{
	%obj.mountImage(STWoodAxeImage, 0, 0, 0);
}

function STWoodAxeImage::onPreFire(%this,%obj,%slot)
{
	%obj.bowChargeTime = getSimTime();
}

function STWoodAxeImage::onFireCut(%this,%obj,%slot)
{
   	%raycastWeaponRange = 3;
   	%raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   					$TypeMasks::PlayerObjectType |	//AI/Players
   					$TypeMasks::StaticObjectType |	//Static Shapes
   					$TypeMasks::TerrainObjectType |	//Terrain
   					$TypeMasks::VehicleObjectType;	//Vehicles
   	%raycastWeaponPierceTargets = "";
   	%raycastExplosionProjectile = STWoodAxeCutProjectile;				//Gun cannot pierce
   	%raycastExplosionPlayerSound = PHitSound;
   	%raycastExplosionBrickSound = WoodHitSound;
   	%raycastDirectDamage = 10;
   	%raycastDirectDamageType = $DamageType::STWoodAxe;
	%raycastFromMuzzle	= false;

	%projectile = STWoodAxeCutprojectile;
	%spread = 0.0000;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}
function STWoodAxeImage::onFireLunge(%this,%obj,%slot)
{
   	%raycastWeaponRange = 3;
   	%raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   					$TypeMasks::PlayerObjectType |	//AI/Players
   					$TypeMasks::StaticObjectType |	//Static Shapes
   					$TypeMasks::TerrainObjectType |	//Terrain
   					$TypeMasks::VehicleObjectType;	//Vehicles
   	%raycastWeaponPierceTargets = "";
   	%raycastExplosionProjectile = STWoodAxeLungeProjectile;				//Gun cannot pierce
   	%raycastExplosionPlayerSound = PHitSound;
   	%raycastExplosionBrickSound = WoodHitSound;
   	%raycastDirectDamage = 15;
   	%raycastDirectDamageType = $DamageType::STWoodAxe;
	%raycastFromMuzzle	= false;

	%projectile = STWoodAxeLungeprojectile;
	%spread = 0.0000;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}
function STWoodAxeMeleeImage::onFireSwing(%this,%obj,%slot)
{
   	%raycastWeaponRange = 3;
   	%raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   					$TypeMasks::PlayerObjectType |	//AI/Players
   					$TypeMasks::StaticObjectType |	//Static Shapes
   					$TypeMasks::TerrainObjectType |	//Terrain
   					$TypeMasks::VehicleObjectType;	//Vehicles
   	%raycastWeaponPierceTargets = "";
   	%raycastExplosionProjectile = STWoodAxeSwingProjectile;				//Gun cannot pierce
   	%raycastExplosionPlayerSound = PHitSound;
   	%raycastExplosionBrickSound = WoodHitSound;
   	%raycastDirectDamage = 15;
   	%raycastDirectDamageType = $DamageType::STWoodAxe;
	%raycastFromMuzzle	= false;

	%projectile = STWoodAxeSwingprojectile;
	%spread = 0.0000;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function STWoodAxeImage::onFire(%this, %obj, %slot)
{
	if(getRandom(0,1))
	{
		%this.raycastExplosionBrickSound = WoodHit1Sound;
		%this.raycastExplosionPlayerSound = PHitSound;
	}
	else
	{
		%this.raycastExplosionBrickSound = WoodHit1Sound;
		%this.raycastExplosionPlayerSound = PHit2Sound;
	}
	WeaponImage::onFire(%this, %obj, %slot);
}

function DrawSTWoodAxeImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.playThread(0, armreadyboth);
  	if(%obj.getMountedImage(1))
	{
		%obj.unMountImage(1);
		%obj.hideNode("RHand");
		%obj.hideNode("RHook");
		%obj.hideNode("LHand");
		%obj.hideNode("LHook");
	}
}

function DrawSTWoodAxeImage::onUnMount(%this, %obj, %slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.playThread(0, root);
  	%obj.unMountImage(1);
  	%obj.mountImage(STWoodAxeBackImage,1);
	%obj.unHideNode("ALL");
	if(isObject(%obj.client))
	{
		%obj.client.applyBodyParts();
		%obj.client.applyBodyColors();
	}
	else
	{
		applyDefaultCharacterPrefs(%obj);
	}
}

function STWoodAxeImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.playThread(0, armreadyboth);
  	if(%obj.getMountedImage(1))
	{
		%obj.unMountImage(1);
		%obj.hideNode("RHand");
		%obj.hideNode("RHook");
		%obj.hideNode("LHand");
		%obj.hideNode("LHook");
	}
}

function STWoodAxeImage::onUnMount(%this, %obj, %slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.playThread(0, root);
  	%obj.unMountImage(1);
  	%obj.mountImage(STWoodAxeBackImage,1);
	%obj.unHideNode("ALL");
	if(isObject(%obj.client))
	{
		%obj.client.applyBodyParts();
		%obj.client.applyBodyColors();
	}
	else
	{
		applyDefaultCharacterPrefs(%obj);
	}
}

package STWoodAxeDropPackage
{
  function servercmdDropTool(%this,%slot)
  {
	parent::servercmdDropTool(%this,%slot);
	%this.player.schedule(5,unmountimage,1);
	%this.player.schedule(5,unmountimage,0);
  }
};
activatepackage(STWoodAxeDropPackage);

package STWoodAxeMelee
{
	function armor::onTrigger(%this, %obj, %triggerNum, %val)
	{
		%client = %obj.client;
		if(%triggerNum == 4 && %obj.isImageMounted(STWoodAxeImage))
		{
			%obj.mountImage(STWoodAxeMeleeImage, 0, 0, 0);
		}
		Parent::onTrigger(%this, %obj, %triggerNum, %val);
	}
};
activatePackage(STWoodAxeMelee);

datablock ShapeBaseImageData(STWoodAxeMeleeImage)
{
   shapeFile = "./Models/STWoodAxe.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   rotation = eulerToMatrix("0 0 0");
   eyeOffset = "0 0 -2.0";
   correctMuzzleVector = false;
   className = "WeaponImage";
   item = STWoodAxeItem;
   ammo = " ";
   projectile = STWoodAxeSwingProjectile;
   projectileType = Projectile;
   melee = true;
   canDrop = true;
   doRetraction = false;
   armReady = true;
   doColorShift = false;
   
   raycastWeaponRange = 3;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType;	//Terrain
   raycastExplosionProjectile = STWoodAxeSwingProjectile;
   raycastExplosionBrickSound = WoodHit1Sound;
   raycastExplosionPlayerSound = PHitSound;
   raycastDirectDamage = 15;
   raycastDirectDamageType = $DamageType::STWoodAxeMelee;
   
	stateName[0]			= "Equip";
	stateTimeoutValue[0]		= 0.01;
	stateSequence[0]		= "Slice2";
	stateTransitionOnTimeout[0]	= "Attack";
	//stateScript[0]			= "onEquip";

	stateName[1]			= "Attack";
	stateTimeoutValue[1]		= 0.2;
	stateWaitForTimeout[1]		= true;
	stateSound[1]			= SwingLarge1Sound;
	stateSequence[1]		= "Slice1";
	stateTransitionOnTimeout[1]	= "Att2";

	stateName[2]			= "UnEquip";
	stateTimeoutValue[2]		= 0.01;
	stateScript[2]			= "onUnEquip";

	stateName[3]			= "Att2";
	stateTimeoutValue[3]		= 1.0;
	stateWaitForTimeout[3]		= true;
	stateSequence[3]		= "Slice2";
	stateFire[3]			= true;
	stateScript[3]			= "onFireSwing";
	stateTransitionOnTimeout[3]	= "UnEquip";
};
function STWoodAxeMeleeImage::onUnEquip(%this, %obj, %slot)
{
	%obj.unMountImage(0);
	%obj.MountImage(STWoodAxeImage, 0, 0, 0);
}


function STWoodAxeMeleeImage::onMount(%this, %obj, %slot)
{		
	Parent::onMount(%this,%obj,%slot);
	//%obj.playThread(1, armreadyboth);
  	if(%obj.getMountedImage(1))
	{
		%obj.unMountImage(1);
		%obj.hideNode("RHand");
		%obj.hideNode("RHook");
		%obj.hideNode("LHand");
		%obj.hideNode("LHook");
	}
}


function STWoodAxeMeleeImage::onUnMount(%this, %obj, %slot)
{	
	Parent::onUnMount(%this,%obj,%slot);
	//%obj.playThread(0, root);
  	%obj.unMountImage(1);
  	%obj.mountImage(STWoodAxeBackImage,1);
	%obj.unHideNode("ALL");
	if(isObject(%obj.client))
	{
		%obj.client.applyBodyParts();
		%obj.client.applyBodyColors();
	}
	else
	{
		applyDefaultCharacterPrefs(%obj);
	}
}
function STWoodAxeSwingProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)

{

	parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);

	if(%col.getClassName() $= "fxDTSBrick")

	{

		$InputTarget_["Self"] = %col;

		$InputTarget_["Player"] = %obj.client.player;

		$InputTarget_["Client"] = %obj.client;

		if($Server::LAN)

		{

			$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj.client);

		}

		else

		{

			if(getMiniGameFromObject(%col) == getMiniGameFromObject(%obj.client))

			{

				$InputTarget_["MiniGame"] = getMiniGameFromObject(%col);

			}

			else

			{

				$InputTarget_["MiniGame"] = 0;

			}

		}

		%col.processInputEvent(OnSteelWoodAxeSwing,%obj.client);

	}

}
function STWoodAxeLungeProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)

{

	parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);

	if(%col.getClassName() $= "fxDTSBrick")

	{

		$InputTarget_["Self"] = %col;

		$InputTarget_["Player"] = %obj.client.player;

		$InputTarget_["Client"] = %obj.client;

		if($Server::LAN)

		{

			$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj.client);

		}

		else

		{

			if(getMiniGameFromObject(%col) == getMiniGameFromObject(%obj.client))

			{

				$InputTarget_["MiniGame"] = getMiniGameFromObject(%col);

			}

			else

			{

				$InputTarget_["MiniGame"] = 0;

			}

		}

		%col.processInputEvent(OnSteelWoodAxeLunge,%obj.client);

	}

}
function STWoodAxeCutProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)

{

	parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);

	if(%col.getClassName() $= "fxDTSBrick")

	{

		$InputTarget_["Self"] = %col;

		$InputTarget_["Player"] = %obj.client.player;

		$InputTarget_["Client"] = %obj.client;

		if($Server::LAN)

		{

			$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj.client);

		}

		else

		{

			if(getMiniGameFromObject(%col) == getMiniGameFromObject(%obj.client))

			{

				$InputTarget_["MiniGame"] = getMiniGameFromObject(%col);

			}

			else

			{

				$InputTarget_["MiniGame"] = 0;

			}

		}

		%col.processInputEvent(OnSteelWoodAxeCut,%obj.client);

	}

}