datablock AudioProfile(WoodLongBowpullSound)
{
	filename="./Sounds/WoodLongBowPull.wav";
	description=AudioClosest3d;
	preload=true;
};

datablock AudioProfile(WoodLongBowFireSound)
{
	filename="./Sounds/WoodLongBowfire.wav";
	description=AudioClose3d;
	preload=true;
};

AddDamageType("WoodLongBow",   '<color:00FF00>Ranged<color:FFFFFF> %1',    '%2 <color:00FF00>Ranged %1',0.75,1);
datablock ProjectileData(WoodLongBowRegProjectile)
{
	uiName="";
	projectileShapeName="Add-Ons/Weapon_ZLRP_Pack/Models/Arrow.dts";
   	directDamage        = 10;
   	directDamageType    = $DamageType::WoodLongBow;
   	radiusDamage        = 0;
   	damageRadius        = 0;
   	radiusDamageType    = $DamageType::WoodLongBow;
	brickExplosionRadius=0;
	brickExplosionImpact=false;
	brickExplosionForce=15;
	brickExplosionMaxVolume=1;
	brickExplosionMaxVolumeFloating=2;
	impactImpulse=60;
	muzzleVelocity=70;
	verInheritFactor=1;
   	explosion             = arrowExplosion;
   	stickExplosion        = arrowStickExplosion;
   	bloodExplosion        = arrowStickExplosion;
   	particleEmitter       = arrowTrailEmitter;
   	explodeOnPlayerImpact = true;
   	explodeOnDeath        = true;  
	lifetime=30000;
	fadeDelay=29900;
   	armingDelay= 30000;
   	bounceAngle= 170;
   	minStickVelocity= 10;
	bounceElasticity=0.2;
	bounceFriction=0.2;
	isBallistic=true;
	gravityMod=1.0;
	sound=CpBowWhizSound;

};

AddDamageType("WoodLongBowFire",   '<color:00FF00>RangedFire<color:FFFFFF> %1',    '%2 <color:00FF00>RangedFire %1',0.75,1);
datablock ProjectileData(WoodLongBowFireProjectile)
{
	uiName="";
	projectileShapeName="Add-Ons/Weapon_ZLRP_Pack/Models/Arrow.dts";
   	directDamage        = 9;
   	directDamageType    = $DamageType::WoodLongBowFire;
   	radiusDamage        = 10;
   	radiusDamageType    = $DamageType::WoodLongBowFire;
   	explosion = CpFireMExplosion;
   	particleEmitter = CpFireAmbientEmitter;impactImpulse=60;
	muzzleVelocity=70;verInheritFactor=1;explodeOnPlayerImpact = true;explodeOnDeath        = true;  lifetime=30000;fadeDelay=29900;armingDelay= 0;bounceAngle= 170;minStickVelocity= 10;bounceElasticity=0.2;bounceFriction=0.2;isBallistic=true;gravityMod=1.0;
	sound=CpBowWhizSound;

};
function WoodLongBowFireProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
{
	if(%col.getClassName() $= "TSStatic")
	{
		if(%col.shapeName $= "Add-Ons/Weapon_ZLRP_Pack/OtherShapes/IceBlock.dts")
		{
			if(isObject(%col.player))
			{
				%col.player.thaw();
			}
			%col.delete();
		}
	}
	parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
}

function WoodLongBowFireProjectile::RadiusDamage(%this, %obj, %col, %distance, %pos, %amt)
{
	if(!isObject(%col))
	{
		return;
	}
	%col.damage(%obj, %pos, 15 * getWord(%col.getScale(), 2), $DamageType::WoodLongBowFire);
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
AddDamageType("WoodLongBowIce",   '<color:00FF00>RangedIce<color:FFFFFF> %1',    '%2 <color:00FF00>RangedIce %1',0.75,1);
datablock ProjectileData(WoodLongBowIceProjectile)
{
	uiName="";
	projectileShapeName="Add-Ons/Weapon_ZLRP_Pack/Models/Arrow.dts";
   	directDamage        = 15;
   	directDamageType    = $DamageType::WoodLongBowIce;
   	radiusDamageType    = $DamageType::WoodLongBowIce;

	brickExplosionRadius = 0;
	brickExplosionImpact = true;
	brickExplosionForce = 0;
	brickExplosionMaxVolume = 1;
	brickExplosionMaxVolumeFloating = 2;

   	explosion = CpIceMExplosion;
   	particleEmitter = CpIceTrailEmitter;impactImpulse=60;
	muzzleVelocity=70;verInheritFactor=1;  lifetime=30000;fadeDelay=29900;armingDelay= 0;bounceAngle= 170;minStickVelocity= 10;bounceElasticity=0.2;bounceFriction=0.2;isBallistic=true;gravityMod=1.0;
	sound=CpBowWhizSound;
	hasLight = true;
	lightRadius = 5;
	lightColor = "0.5 1 1";

};

datablock StaticShapeData(CpIceBlockData)
{
	category = "Statics";
	shapeFile = "Add-Ons/Weapon_ZLRP_Pack/OtherShapes/IceBlock.dts";
	skinName = 'null';
};

function WoodLongBowIceProjectile::Damage(%this, %obj, %col, %fade, %pos, %normal)
{
	if(%col.getType() & $Typemasks::PlayerObjectType && (%col.lastFreezeTime + 10000) < getSimTime() && %col.getMountedImage(0) != WoodLongBowFireImage.getID())
	{
		%col.lastFreezeTime = getSimTime();
		%col.setVelocity("0 0 0");
		//Variables for thaw function
		%col.thawData = %col.getDatablock();
		%col.thawImg0 = %col.getMountedImage(0);
		%col.thawImg1 = %col.getMountedImage(1);
		%col.thawClient = %col.getControllingClient();
		if(!isObject(%col.client))
		{
			%col.thawSched = %col.schedule(5000, thaw);
		}
		else
		{
			%col.client.thawSched = %col.client.schedule(5000, thaw);
		}
		//Stop player from being able to do anything in case they're a bot
		%col.unmountImage(0);
		%col.unmountImage(1);
		%col.setDatablock(PlayerNoMoveArmor);
		if(isObject(%client = %col.getControllingClient()) && isObject(%client.camera))
		{
			%client.camera.frozen = true;
			%client.camera.setMode("Corpse", %col);
			%client.setControlObject(%client.camera);
		}
		%scale = %col.getScale();
		%nPos = %col.getPosition();
		%rot = rotFromTransform(%col.getTransform());
		%block = new TSstatic()
		{
			datablock = CpIceBlockData;
			shapeName = "Add-Ons/Weapon_ZLRP_Pack/OtherShapes/IceBlock.dts";
			position = %nPos;
			rotation = %rot;
			scale = %scale;
			player = %col;
		};
		MissionCleanup.add(%block);
		%block.schedule(5000, spawnCpIceExplosion, %block, %nPos, getWord(%scale, 2));
		%block.schedule(5000, delete);
	}
}

function GameConnection::Thaw(%client)
{
	if(isObject(%client.camera) && %client.getControlObject() == %client.camera || !isObject(%client.getControlObject()))
	{
		%client.camera.unmountImage(0);
		%client.camera.frozen = false;
	}
	if(isObject(%obj = %client.player))
	{
		if(%obj.getDamagePercent() < 1)
		{
			%client.setControlObject(%obj);
			%obj.setDatablock(%obj.thawData);
		}
		for(%i = 0; %i < 1; %i++)
		{
			if(isObject(%obj.thawImg[%i]))
			{
				%obj.mountImage(%obj.thawImg[%i], %i);
			}
		}
	}
}
function Player::Thaw(%obj)
{
	%obj.setDatablock(%obj.thawData);
	for(%i = 0; %i < 1; %i++)
	{
		if(isObject(%obj.thawImg[%i]))
		{
			%obj.mountImage(%obj.thawImg[%i], %i);
		}
	}
	if(isObject(%obj.thawClient.camera) && %obj.thawClient.getControlObject() == %obj.thawClient.camera)
	{
		%obj.thawClient.camera.unmountImage(0); //Just in case they were flying around
		%obj.thawClient.camera.frozen = false;
		%obj.thawClient.setControlObject(%obj);
	}
}

function TSstatic::SpawnCpIceExplosion(%obj, %pos, %scale)
{
	%proj = new projectile()
	{
		datablock = WoodLongBowIceProjectile;
		initialPosition = vectorAdd(%pos, "0 0" @ %scale);
		initialVelocity = "0 0 5";
		scale = %scale SPC %scale SPC %scale;
		sourceObject = "";
		sourceSlot = 0;
		client = "";
		hot = true;
	};
	%proj.schedule(33, explode);
}

function WoodLongBowIceProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
{
		parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
		if(%col.getType() & $TypeMasks::InteriorObjectType || %col.getType() & $TypeMasks::FxBrickObjectType || %col.getType() & $TypeMasks::TerrainObjectType)
		{
			%scale = getWord(%obj.getScale(), 2);
			%block = new TSstatic()
			{
				datablock = CpIceBlockData;
				shapeName = "Add-Ons/Weapon_ZLRP_Pack/OtherShapes/IceBlock.dts";
				position = %pos;
				rotation = "0 0 0 0";
				scale = %scale SPC %scale SPC %scale;
			};
			MissionCleanup.add(%block);
			%block.schedule(5000, 0, spawnCpIceExplosion, %block, %pos, %scale);
			%block.schedule(5000, delete);
		}
}
package CpMagicIce
{
	function player::mountImage(%obj, %image, %slot)
	{
		if(%obj.getDatablock() == PlayerNoMoveArmor.getID())
		{
			return;
		}
		parent::mountImage(%obj, %image, %slot);
	}
	function observer::onTrigger(%this, %obj, %slot, %val)
	{
		if(%obj.frozen)
		{
			return;
		}
		parent::onTrigger(%this, %obj, %slot, %val);
	}
	function GameConnection::onDeath(%this, %sObj, %sClient, %dType, %dLoc)
	{
		parent::onDeath(%this, %sObj, %sClient, %dType, %dLoc);
		if(!isObject(%this.getControlObject()))
		{
			%this.setControlObject(%this.camera);
			%this.camera.setMode("Corpse", %this.player);
		}
	}
};
activatePackage(CpMagicIce);
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
AddDamageType("WoodLongBowExp",   '<color:00FF00>RangedExp<color:FFFFFF> %1',    '%2 <color:00FF00>RangedExp %1',0.75,1);
datablock ProjectileData(WoodLongBowExpProjectile)
{
	uiName="";
	projectileShapeName="Add-Ons/Weapon_ZLRP_Pack/Models/ArrowExp.dts";
   	directDamage        = 20;
   	directDamageType    = $DamageType::WoodLongBowExp;
   	radiusDamage        = 10;
   	radiusDamageType    = $DamageType::WoodLongBowExp;
	brickExplosionRadius=0;
	brickExplosionImpact=false;
	brickExplosionForce=0;
	brickExplosionMaxVolume=1;
	brickExplosionMaxVolumeFloating=2;
	impactImpulse=60;
	muzzleVelocity=50;
	verInheritFactor=1;
   	explosion             = CpExpExplosion;
   	particleEmitter       = arrowTrailEmitter;
   	explodeOnDeath	     = true;
	lifetime=30000;
	fadeDelay=29900;
   	armingDelay= 0;
   	bounceAngle= 170;
   	minStickVelocity= 170;
	bounceElasticity=0.2;
	bounceFriction=0.2;
	isBallistic=true;
	gravityMod=1.0;
	sound=CpBowWhizSound;

};
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
datablock ItemData(WoodLongBowItem)
{
	uiName="WoodLongBow";
	iconName="./icon_WoodLongBow";
	image=WoodLongBowimage;
	category=Weapon;
	className=Weapon;
	shapeFile="./Models/DumWoodLongBow.dts";
	mass=1;
	density=0.2;
	elasticity=0;
	friction=0.6;
	emap=true;
	doColorShift=false;
	colorShiftColor="1 1 1 1";
	canDrop=true;
	maxAmmo = 0;
	canReload = 1;
};

datablock shapeBaseimageData(WoodLongBowimage)
{
	shapeFile="./Models/WoodLongBow.dts";
	emap=true;
	correctMuzzleVector=true;
	className="Weaponimage";
	item=WoodLongBowItem;
	ammo="";
	projectile=WoodLongBowRegProjectile;
	projectileType=Projectile;
	melee=true;
	doReaction=false;
	armReady=true;
	doColorShift=false;
	colorShiftColor="1 1 1 1";
   	mountPoint = 0;
   	offset = "0 0 0";
   	eyeOffset = "-0.1 0 -2.28";
   	rotation = eulerToMatrix( "0 0 0" );
	
	stateName[0]                    = "Activate";
	stateSequence[0]		= "Draw";
	stateTimeoutValue[0]            = 1.5;
	stateTransitionOnTimeout[0]     = "LoadCheckA";
	stateScript[0]                  = "onHide";

	stateName[1]                    = "Ready";
	stateTransitionOnNoAmmo[1]	= "ClipOut";
	stateTransitionOnTriggerDown[1] = "Pull";
	stateAllowImageChange[1]        = true;

	stateName[2]                    = "Fire";
	stateTimeoutValue[2]            = 0.5;
	stateTransitionOnTimeout[2]     = "Prep";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateSequence[2]		= "Fire";
	stateWaitForTimeout[2]		= true;
	stateSound[2]			= WoodLongBowFireSound;
	stateEjectShell[2]              = false;

	stateName[3] 			= "Prep";
	stateAllowImageChange[3]        = false;
	stateTimeoutValue[3]	= 0.4;
	stateSequence[3]		= "Prep";
	stateTransitionOnTimeout[3]	= "FireLoadCheckA";

	stateName[4]			= "Wait";
	stateTimeoutValue[4]		= 0.01;
	stateAllowImageChange[4]        = true;
	stateScript[4]                  = "";
	stateTransitionOnTriggerUp[4] = "Delay";
	
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "ReadyWeap3";
	stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.001;
	stateScript[7]				= "";
	stateTransitionOnTimeout[7]		= "ClipOut";

	stateName[8]				= "ClipOut";
	stateTimeoutValue[8]			= 0.001;
	stateScript[8]				= "onReloadStart";
	stateAllowImageChange[8]        = true;
	stateTransitionOnTimeout[8]		= "ClipIn";
	stateSound[8]				= ASM200clipoutSound;
	
	stateName[9]				= "ClipIn";
	stateTimeoutValue[9]			= 0.001;
	stateAllowImageChange[9]        = true;
	stateSequence[9]			= "Reload";
	stateTransitionOnTimeout[9]		= "reloadFinish";
	
	stateName[10]				= "reloadFinish";
	stateTimeoutValue[10]			= 0.001;
	stateAllowImageChange[10]        = false;
	stateScript[10]				= "onReloaded";
	stateTransitionOnTimeout[10]		= "Ready";
	
	stateName[11]				= "FireLoadCheckA";
	stateScript[11]				= "onLoadCheck";
	stateTimeoutValue[11]			= 0.01;
	stateTransitionOnTimeout[11]		= "FireLoadCheckB";
	
	stateName[12]				= "FireLoadCheckB";
	stateTransitionOnAmmo[12]		= "Wait";
	stateTransitionOnNoAmmo[12]		= "ReloadWait";
	
	stateName[13]				= "Delay";
	stateTransitionOnTimeout[13]		= "Ready";
	stateTimeoutValue[13] 			= 0.00001;
	
	stateName[14]				= "ReadyWeap3";
	stateTransitionOnTimeout[14]		= "Ready";

	stateName[15] 			= "Pull";
	stateAllowImageChange[15]        = false;
	stateTimeoutValue[15]	= 1.2;
	stateTransitionOnTriggerUp[15] = "Abort";
	stateSequence[15]		= "Pull";
	stateTransitionOnTimeout[15]	= "Set";
	stateSound[15]				= WoodLongBowPullSound;
	stateWaitForTimeout[15]	= false;

	stateName[16] 			= "Set";
	stateTransitionOnTriggerUp[16] = "Fire";
	stateAllowImageChange[16]	= false;
	stateTimeoutValue[16]            = 3.0;
	stateWaitForTimeout[16]		= false;

	stateName[17] 			= "Abort";
	stateSequence[17]		= "Prep";
	stateTransitionOnTimeout[17]	= "Ready";
	stateWaitForTimeout[17]		= true;
	stateAllowImageChange[17]	= false;
	stateTimeoutValue[17]		= 0.4;
};
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
datablock shapeBaseimageData(WoodLongBowFireimage)
{
	shapeFile="./Models/WoodLongBow.dts";
	emap=true;
	correctMuzzleVector=true;
	className="Weaponimage";
	item=WoodLongBowItem;
	ammo="";
	projectile=WoodLongBowFireProjectile;
	projectileType=Projectile;
	melee=true;
	doReaction=false;
	armReady=true;
	doColorShift=false;
	colorShiftColor="1 1 1 1";
   	mountPoint = 0;
   	offset = "0 0 0";
   	eyeOffset = "-0.1 0 -2.28";
   	rotation = eulerToMatrix( "0 0 0" );
	
	stateName[0]                    = "Activate";
	stateAllowImageChange[0]        = false;
	stateTimeoutValue[0]	= 0.4;
	stateSequence[0]		= "Prep";
	stateTransitionOnTimeout[0]     = "LoadCheckA";
	stateScript[0]                  = "onHide";

	stateName[1]                    = "Ready";
	stateTransitionOnNoAmmo[1]	= "ClipOut";
	stateTransitionOnTriggerDown[1] = "Pull";
	stateAllowImageChange[1]        = true;

	stateName[2]                    = "Fire";
	stateTimeoutValue[2]            = 0.5;
	stateTransitionOnTimeout[2]     = "Prep";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateSequence[2]		= "Fire";
	stateWaitForTimeout[2]		= true;
	stateSound[2]			= WoodLongBowFireSound;
	stateEjectShell[2]              = false;

	stateName[3] 			= "Prep";
	stateAllowImageChange[3]        = false;
	stateTimeoutValue[3]	= 0.4;
	stateSequence[3]		= "Prep";
	stateTransitionOnTimeout[3]	= "FireLoadCheckA";

	stateName[4]			= "Wait";
	stateTimeoutValue[4]		= 0.01;
	stateAllowImageChange[4]        = true;
	stateScript[4]                  = "";
	stateTransitionOnTriggerUp[4] = "Delay";
	
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "ReadyWeap3";
	stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.001;
	stateScript[7]				= "";
	stateTransitionOnTimeout[7]		= "ClipOut";

	stateName[8]				= "ClipOut";
	stateTimeoutValue[8]			= 0.001;
	stateScript[8]				= "onReloadStart";
	stateAllowImageChange[8]        = true;
	stateTransitionOnTimeout[8]		= "ClipIn";
	stateSound[8]				= ASM200clipoutSound;
	
	stateName[9]				= "ClipIn";
	stateTimeoutValue[9]			= 0.001;
	stateAllowImageChange[9]        = true;
	stateSequence[9]			= "Reload";
	stateTransitionOnTimeout[9]		= "reloadFinish";
	
	stateName[10]				= "reloadFinish";
	stateTimeoutValue[10]			= 0.001;
	stateAllowImageChange[10]        = false;
	stateScript[10]				= "onReloaded";
	stateTransitionOnTimeout[10]		= "Ready";
	
	stateName[11]				= "FireLoadCheckA";
	stateScript[11]				= "onLoadCheck";
	stateTimeoutValue[11]			= 0.01;
	stateTransitionOnTimeout[11]		= "FireLoadCheckB";
	
	stateName[12]				= "FireLoadCheckB";
	stateTransitionOnAmmo[12]		= "Wait";
	stateTransitionOnNoAmmo[12]		= "ReloadWait";
	
	stateName[13]				= "Delay";
	stateTransitionOnTimeout[13]		= "Ready";
	stateTimeoutValue[13] 			= 0.00001;
	
	stateName[14]				= "ReadyWeap3";
	stateTransitionOnTimeout[14]		= "Ready";

	stateName[15] 			= "Pull";
	stateAllowImageChange[15]        = false;
	stateTimeoutValue[15]	= 1.0;
	stateTransitionOnTriggerUp[15] = "Abort";
	stateSequence[15]		= "Pull";
	stateTransitionOnTimeout[15]	= "Set";
	stateSound[15]				= WoodLongBowPullSound;
	stateWaitForTimeout[15]	= false;
	stateEmitter[15]			= CpFireAmbientEmitter;
	stateEmitterTime[15]		= 0.01;
	stateEmitterNode[15]		= "muzzleNode";

	stateName[16] 			= "Set";
	stateTransitionOnTriggerUp[16] = "Fire";
	stateAllowImageChange[16]	= false;
	stateTimeoutValue[16]            = 3.0;
	stateWaitForTimeout[16]		= false;
	stateEmitter[16]			= CpFireAmbientEmitter;
	stateEmitterTime[16]		= 0.01;
	stateEmitterNode[16]		= "muzzleNode";

	stateName[17] 			= "Abort";
	stateSequence[17]		= "Prep";
	stateTransitionOnTimeout[17]	= "Ready";
	stateWaitForTimeout[17]		= true;
	stateAllowImageChange[17]	= false;
	stateTimeoutValue[17]		= 0.4;
};
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
datablock shapeBaseimageData(WoodLongBowIceimage)
{
	shapeFile="./Models/WoodLongBow.dts";
	emap=true;
	correctMuzzleVector=true;
	className="Weaponimage";
	item=WoodLongBowItem;
	ammo="";
	projectile=WoodLongBowIceProjectile;
	projectileType=Projectile;
	melee=true;
	doReaction=false;
	armReady=true;
	doColorShift=false;
	colorShiftColor="1 1 1 1";
   	mountPoint = 0;
   	offset = "0 0 0";
   	eyeOffset = "-0.1 0 -2.28";
   	rotation = eulerToMatrix( "0 0 0" );
	
	stateName[0]                    = "Activate";
	stateAllowImageChange[0]        = false;
	stateTimeoutValue[0]	= 0.4;
	stateSequence[0]		= "Prep";
	stateTransitionOnTimeout[0]     = "LoadCheckA";
	stateScript[0]                  = "onHide";

	stateName[1]                    = "Ready";
	stateTransitionOnNoAmmo[1]	= "ClipOut";
	stateTransitionOnTriggerDown[1] = "Pull";
	stateAllowImageChange[1]        = true;

	stateName[2]                    = "Fire";
	stateTimeoutValue[2]            = 0.5;
	stateTransitionOnTimeout[2]     = "Prep";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateSequence[2]		= "Fire";
	stateWaitForTimeout[2]		= true;
	stateSound[2]			= WoodLongBowFireSound;
	stateEjectShell[2]              = false;

	stateName[3] 			= "Prep";
	stateAllowImageChange[3]        = false;
	stateTimeoutValue[3]	= 0.4;
	stateSequence[3]		= "Prep";
	stateTransitionOnTimeout[3]	= "FireLoadCheckA";

	stateName[4]			= "Wait";
	stateTimeoutValue[4]		= 0.01;
	stateAllowImageChange[4]        = true;
	stateScript[4]                  = "";
	stateTransitionOnTriggerUp[4] = "Delay";
	
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "ReadyWeap3";
	stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.001;
	stateScript[7]				= "";
	stateTransitionOnTimeout[7]		= "ClipOut";

	stateName[8]				= "ClipOut";
	stateTimeoutValue[8]			= 0.001;
	stateScript[8]				= "onReloadStart";
	stateAllowImageChange[8]        = true;
	stateTransitionOnTimeout[8]		= "ClipIn";
	stateSound[8]				= ASM200clipoutSound;
	
	stateName[9]				= "ClipIn";
	stateTimeoutValue[9]			= 0.001;
	stateAllowImageChange[9]        = true;
	stateSequence[9]			= "Reload";
	stateTransitionOnTimeout[9]		= "reloadFinish";
	
	stateName[10]				= "reloadFinish";
	stateTimeoutValue[10]			= 0.001;
	stateAllowImageChange[10]        = false;
	stateScript[10]				= "onReloaded";
	stateTransitionOnTimeout[10]		= "Ready";
	
	stateName[11]				= "FireLoadCheckA";
	stateScript[11]				= "onLoadCheck";
	stateTimeoutValue[11]			= 0.01;
	stateTransitionOnTimeout[11]		= "FireLoadCheckB";
	
	stateName[12]				= "FireLoadCheckB";
	stateTransitionOnAmmo[12]		= "Wait";
	stateTransitionOnNoAmmo[12]		= "ReloadWait";
	
	stateName[13]				= "Delay";
	stateTransitionOnTimeout[13]		= "Ready";
	stateTimeoutValue[13] 			= 0.00001;
	
	stateName[14]				= "ReadyWeap3";
	stateTransitionOnTimeout[14]		= "Ready";

	stateName[15] 			= "Pull";
	stateAllowImageChange[15]        = false;
	stateTimeoutValue[15]	= 1.0;
	stateTransitionOnTriggerUp[15] = "Abort";
	stateSequence[15]		= "Pull";
	stateTransitionOnTimeout[15]	= "Set";
	stateSound[15]				= WoodLongBowPullSound;
	stateWaitForTimeout[15]	= false;
	stateEmitter[15]			= CpIceAmbientEmitter;
	stateEmitterTime[15]		= 0.01;
	stateEmitterNode[15]		= "muzzleNode";

	stateName[16] 			= "Set";
	stateTransitionOnTriggerUp[16] = "Fire";
	stateAllowImageChange[16]	= false;
	stateTimeoutValue[16]            = 3.0;
	stateWaitForTimeout[16]		= false;
	stateEmitter[16]			= CpIceAmbientEmitter;
	stateEmitterTime[16]		= 0.01;
	stateEmitterNode[16]		= "muzzleNode";

	stateName[17] 			= "Abort";
	stateSequence[17]		= "Prep";
	stateTransitionOnTimeout[17]	= "Ready";
	stateWaitForTimeout[17]		= true;
	stateAllowImageChange[17]	= false;
	stateTimeoutValue[17]		= 0.4;
};
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
datablock shapeBaseimageData(WoodLongBowExpimage)
{
	shapeFile="./Models/WoodLongBow.dts";
	emap=true;
	correctMuzzleVector=true;
	className="Weaponimage";
	item=WoodLongBowItem;
	ammo="";
	projectile=WoodLongBowExpProjectile;
	projectileType=Projectile;
	melee=true;
	doReaction=false;
	armReady=true;
	doColorShift=false;
	colorShiftColor="1 1 1 1";
   	mountPoint = 0;
   	offset = "0 0 0";
   	eyeOffset = "-0.1 0 -2.28";
   	rotation = eulerToMatrix( "0 0 0" );
	
	stateName[0]                    = "Activate";
	stateAllowImageChange[0]        = false;
	stateTimeoutValue[0]	= 0.4;
	stateSequence[0]		= "Prep";
	stateTransitionOnTimeout[0]     = "LoadCheckA";
	stateScript[0]                  = "onHide";

	stateName[1]                    = "Ready";
	stateTransitionOnNoAmmo[1]	= "ClipOut";
	stateTransitionOnTriggerDown[1] = "Pull";
	stateAllowImageChange[1]        = true;

	stateName[2]                    = "Fire";
	stateTimeoutValue[2]            = 0.5;
	stateTransitionOnTimeout[2]     = "Prep";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateSequence[2]		= "Fire";
	stateWaitForTimeout[2]		= true;
	stateSound[2]			= WoodLongBowFireSound;
	stateEjectShell[2]              = false;

	stateName[3] 			= "Prep";
	stateAllowImageChange[3]        = false;
	stateTimeoutValue[3]	= 0.4;
	stateSequence[3]		= "Prep";
	stateTransitionOnTimeout[3]	= "FireLoadCheckA";

	stateName[4]			= "Wait";
	stateTimeoutValue[4]		= 0.01;
	stateAllowImageChange[4]        = true;
	stateScript[4]                  = "";
	stateTransitionOnTriggerUp[4] = "Delay";
	
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "ReadyWeap3";
	stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.001;
	stateScript[7]				= "";
	stateTransitionOnTimeout[7]		= "ClipOut";

	stateName[8]				= "ClipOut";
	stateTimeoutValue[8]			= 0.001;
	stateScript[8]				= "onReloadStart";
	stateAllowImageChange[8]        = true;
	stateTransitionOnTimeout[8]		= "ClipIn";
	stateSound[8]				= ASM200clipoutSound;
	
	stateName[9]				= "ClipIn";
	stateTimeoutValue[9]			= 0.001;
	stateAllowImageChange[9]        = true;
	stateSequence[9]			= "Reload";
	stateTransitionOnTimeout[9]		= "reloadFinish";
	
	stateName[10]				= "reloadFinish";
	stateTimeoutValue[10]			= 0.001;
	stateAllowImageChange[10]        = false;
	stateScript[10]				= "onReloaded";
	stateTransitionOnTimeout[10]		= "Ready";
	
	stateName[11]				= "FireLoadCheckA";
	stateScript[11]				= "onLoadCheck";
	stateTimeoutValue[11]			= 0.01;
	stateTransitionOnTimeout[11]		= "FireLoadCheckB";
	
	stateName[12]				= "FireLoadCheckB";
	stateTransitionOnAmmo[12]		= "Wait";
	stateTransitionOnNoAmmo[12]		= "ReloadWait";
	
	stateName[13]				= "Delay";
	stateTransitionOnTimeout[13]		= "Ready";
	stateTimeoutValue[13] 			= 0.00001;
	
	stateName[14]				= "ReadyWeap3";
	stateTransitionOnTimeout[14]		= "Ready";

	stateName[15] 			= "Pull";
	stateAllowImageChange[15]        = false;
	stateTimeoutValue[15]	= 1.0;
	stateTransitionOnTriggerUp[15] = "Abort";
	stateSequence[15]		= "Pull";
	stateTransitionOnTimeout[15]	= "Set";
	stateSound[15]				= WoodLongBowPullSound;
	stateWaitForTimeout[15]	= false;

	stateName[16] 			= "Set";
	stateTransitionOnTriggerUp[16] = "Fire";
	stateAllowImageChange[16]	= false;
	stateTimeoutValue[16]            = 3.0;
	stateWaitForTimeout[16]		= false;

	stateName[17] 			= "Abort";
	stateSequence[17]		= "Prep";
	stateTransitionOnTimeout[17]	= "Ready";
	stateWaitForTimeout[17]		= true;
	stateAllowImageChange[17]	= false;
	stateTimeoutValue[17]		= 0.4;
};	
datablock ShapeBaseImageData(WoodLongBowBackImage)
{
  shapeFile = "./Models/DumWoodLongBow.dts";
  emap = true;
  mountPoint = $BackSlot;
  offset = "0.1 -0.35 -0.15";
  eyeOffset = "0 0 10";
  rotation = eulerToMatrix("-200 0 270");
  armReady = false;
  doColorShift = false;
};

function WoodLongBowImage::onHide(%this,%obj,%slot)
{%obj.hideNode("RHand");%obj.hideNode("RHook");%obj.hideNode("LHand");%obj.hideNode("LHook");}
function WoodLongBowFireImage::onHide(%this,%obj,%slot)
{%obj.hideNode("RHand");%obj.hideNode("RHook");%obj.hideNode("LHand");%obj.hideNode("LHook");}
function WoodLongBowIceImage::onHide(%this,%obj,%slot)
{%obj.hideNode("RHand");%obj.hideNode("RHook");%obj.hideNode("LHand");%obj.hideNode("LHook");}
function WoodLongBowExpImage::onHide(%this,%obj,%slot)
{%obj.hideNode("RHand");%obj.hideNode("RHook");%obj.hideNode("LHand");%obj.hideNode("LHook");}

function WoodLongBowimage::onReloaded(%this,%obj,%slot)
{
    	if(%obj.client.quantity["CpArr"] >= 1)
	{
        	if(%obj.client.quantity["CpArr"] > 1)
		{
			%obj.client.quantity["CpArr"] -= %obj.AmmoSpent[%obj.currTool];
			%obj.toolAmmo[%obj.currTool]=%this.item.maxAmmo;
			%obj.AmmoSpent[%obj.currTool] = 0;
			%obj.setImageAmmo(%slot,1);
        		commandToClient(%obj.client,'bottomPrint',"<just:right><color:ffffff>RegArrows: \c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["CpArr"] @ "", 1, 2, 3, 4); 
			return;
		}
        	if(%obj.client.quantity["CpArr"] <= 1)
		{
			%obj.client.exchangebullets = %obj.client.quantity["CpArr"];
			%obj.toolAmmo[%obj.currTool] = %obj.client.exchangebullets;
			%obj.setImageAmmo(%slot,1);
			%obj.client.quantity["CpArr"] = 0;
        		commandToClient(%obj.client,'bottomPrint',"<just:right><color:ffffff>RegArrows: \c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["CpArr"] @ "", 1, 2, 3, 4); 
			return;
		}
	}
}
function WoodLongBowFireimage::onReloaded(%this,%obj,%slot)
{
    	if(%obj.client.quantity["FireArr"] >= 1)
	{
        	if(%obj.client.quantity["FireArr"] > 1)
		{
			%obj.client.quantity["FireArr"] -= %obj.AmmoSpent[%obj.currTool];
			%obj.toolAmmo[%obj.currTool]=%this.item.maxAmmo;
			%obj.AmmoSpent[%obj.currTool] = 0;
			%obj.setImageAmmo(%slot,1);
        		commandToClient(%obj.client,'bottomPrint',"<just:right><color:ffffff>FireArrows: \c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["FireArr"] @ "", 1, 2, 3, 4); 
			return;
		}
        	if(%obj.client.quantity["FireArr"] <= 1)
		{
			%obj.client.exchangebullets = %obj.client.quantity["FireArr"];
			%obj.toolAmmo[%obj.currTool] = %obj.client.exchangebullets;
			%obj.setImageAmmo(%slot,1);
			%obj.client.quantity["FireArr"] = 0;
        		commandToClient(%obj.client,'bottomPrint',"<just:right><color:ffffff>FireArrows: \c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["FireArr"] @ "", 1, 2, 3, 4); 
			return;
		}
	}
}
function WoodLongBowIceimage::onReloaded(%this,%obj,%slot)
{
    	if(%obj.client.quantity["IceArr"] >= 1)
	{
        	if(%obj.client.quantity["IceArr"] > 1)
		{
			%obj.client.quantity["IceArr"] -= %obj.AmmoSpent[%obj.currTool];
			%obj.toolAmmo[%obj.currTool]=%this.item.maxAmmo;
			%obj.AmmoSpent[%obj.currTool] = 0;
			%obj.setImageAmmo(%slot,1);
        		commandToClient(%obj.client,'bottomPrint',"<just:right><color:ffffff>IceArrows: \c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["IceArr"] @ "", 1, 2, 3, 4); 
			return;
		}
        	if(%obj.client.quantity["IceArr"] <= 1)
		{
			%obj.client.exchangebullets = %obj.client.quantity["IceArr"];
			%obj.toolAmmo[%obj.currTool] = %obj.client.exchangebullets;
			%obj.setImageAmmo(%slot,1);
			%obj.client.quantity["IceArr"] = 0;
        		commandToClient(%obj.client,'bottomPrint',"<just:right><color:ffffff>IceArrows: \c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["IceArr"] @ "", 1, 2, 3, 4); 
			return;
		}
	}
}
function WoodLongBowExpimage::onReloaded(%this,%obj,%slot)
{
	if(%obj.client.quantity["ExpArr"] >= 1)
	{
        	if(%obj.client.quantity["ExpArr"] > 1)
		{
			%obj.client.quantity["ExpArr"] -= %obj.AmmoSpent[%obj.currTool];
			%obj.toolAmmo[%obj.currTool]=%this.item.maxAmmo;
			%obj.AmmoSpent[%obj.currTool] = 0;
			%obj.setImageAmmo(%slot,1);
        		commandToClient(%obj.client,'bottomPrint',"<just:right><color:ffffff>ExpArrows: \c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["ExpArr"] @ "", 1, 2, 3, 4); 
			return;
		}
        	if(%obj.client.quantity["ExpArr"] <= 1)
		{
			%obj.client.exchangebullets = %obj.client.quantity["ExpArr"];
			%obj.toolAmmo[%obj.currTool] = %obj.client.exchangebullets;
			%obj.setImageAmmo(%slot,1);
			%obj.client.quantity["ExpArr"] = 0;
        		commandToClient(%obj.client,'bottomPrint',"<just:right><color:ffffff>ExpArrows: \c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["ExpArr"] @ "", 1, 2, 3, 4); 
			return;
		}
	}
}

package WoodLongBowSA
{
	function serverCmdCancelBrick(%client)
	{
		%obj = %client.player;
		if(%obj.isImageMounted(WoodLongBowFireImage) && %obj.lastHitTime - getSimTime() < 1000)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
			%obj.mountImage(WoodLongBowIceImage, 0, 0, 0);
			commandToClient(%obj.client,'centerPrint',"\c2Ice", 1, 2, 3, 4);
			%client.setControlCameraFov(90);
		}
		else if(%obj.isImageMounted(WoodLongBowIceImage) && %obj.lastHitTime - getSimTime() < 1000)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
			%obj.mountImage(WoodLongBowExpImage, 0, 0, 0);
			commandToClient(%obj.client,'centerPrint',"\c2Exp", 1, 2, 3, 4);
			%client.setControlCameraFov(90); 
		}
		else if(%obj.isImageMounted(WoodLongBowExpImage) && %obj.lastHitTime - getSimTime() < 1000)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
			%obj.mountImage(WoodLongBowImage, 0, 0, 0);
			commandToClient(%obj.client,'centerPrint',"\c2Reg", 1, 2, 3, 4);
			%client.setControlCameraFov(90); 
		}
		else if(%obj.isImageMounted(WoodLongBowImage) && %obj.lastHitTime - getSimTime() < 1000)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
			%obj.mountImage(WoodLongBowFireImage, 0, 0, 0);
			commandToClient(%obj.client,'centerPrint',"\c2Fire", 1, 2, 3, 4);
			%client.setControlCameraFov(90); 
		}
		%obj.lastHitTime = getSimTime();
		parent::serverCmdCancelBrick(%client);
	}
};
activatePackage(WoodLongBowSA);
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function WoodLongBowimage::onMount(%this,%obj,%slot)	
{Parent::onMount(%this,%obj,%slot);%obj.playThread(0, armreadyboth);if(%obj.getMountedImage(1))
	{%obj.unMountImage(1);%obj.hideNode("RHand");%obj.hideNode("RHook");%obj.hideNode("LHand");%obj.hideNode("LHook");}

        commandToClient(%obj.client,'bottomPrint',"<just:right><color:ffffff>RegArrows: \c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["CpArr"] @ "", 1, 2, 3, 4); 
}
function WoodLongBowimage::onUnMount(%this,%obj,%slot)
{parent::onUnMount(%this,%obj,%slot);%obj.playThread(0, root);%obj.unMountImage(1);%obj.mountImage(WoodLongBowBackImage,1);%obj.unhideNode("ALL");
	if(isObject(%obj.client))
	{%obj.client.applyBodyParts();%obj.client.applyBodyColors();}
	else{applyDefaultCharacterPrefs(%obj);}
	%obj.client.setControlCameraFov(90);
}
function WoodLongBowFireimage::onMount(%this,%obj,%slot)	
{Parent::onMount(%this,%obj,%slot);%obj.playThread(0, armreadyboth);if(%obj.getMountedImage(1))
	{%obj.unMountImage(1);%obj.hideNode("RHand");%obj.hideNode("RHook");%obj.hideNode("LHand");%obj.hideNode("LHook");}

        commandToClient(%obj.client,'bottomPrint',"<just:right><color:ffffff>FireArrows: \c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["FireArr"] @ "", 1, 2, 3, 4); 
}
function WoodLongBowFireimage::onUnMount(%this,%obj,%slot)
{parent::onUnMount(%this,%obj,%slot);%obj.playThread(0, root);%obj.unMountImage(1);%obj.mountImage(WoodLongBowBackImage,1);%obj.unhideNode("ALL");
	if(isObject(%obj.client))
	{%obj.client.applyBodyParts();%obj.client.applyBodyColors();}
	else{applyDefaultCharacterPrefs(%obj);}
	%obj.client.setControlCameraFov(90);
}
function WoodLongBowIceimage::onMount(%this,%obj,%slot)	
{Parent::onMount(%this,%obj,%slot);%obj.playThread(0, armreadyboth);if(%obj.getMountedImage(1))
	{%obj.unMountImage(1);%obj.hideNode("RHand");%obj.hideNode("RHook");%obj.hideNode("LHand");%obj.hideNode("LHook");}

        commandToClient(%obj.client,'bottomPrint',"<just:right><color:ffffff>IceArrows: \c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["IceArr"] @ "", 1, 2, 3, 4); 
}
function WoodLongBowIceimage::onUnMount(%this,%obj,%slot)
{parent::onUnMount(%this,%obj,%slot);%obj.playThread(0, root);%obj.unMountImage(1);%obj.mountImage(WoodLongBowBackImage,1);%obj.unhideNode("ALL");
	if(isObject(%obj.client))
	{%obj.client.applyBodyParts();%obj.client.applyBodyColors();}
	else{applyDefaultCharacterPrefs(%obj);}
	%obj.client.setControlCameraFov(90);
}
function WoodLongBowExpimage::onMount(%this,%obj,%slot)	
{Parent::onMount(%this,%obj,%slot);%obj.playThread(0, armreadyboth);if(%obj.getMountedImage(1))
	{%obj.unMountImage(1);%obj.hideNode("RHand");%obj.hideNode("RHook");%obj.hideNode("LHand");%obj.hideNode("LHook");}

        commandToClient(%obj.client,'bottomPrint',"<just:right><color:ffffff>ExpArrows: \c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["ExpArr"] @ "", 1, 2, 3, 4); 
}
function WoodLongBowExpimage::onUnMount(%this,%obj,%slot)
{parent::onUnMount(%this,%obj,%slot);%obj.playThread(0, root);%obj.unMountImage(1);%obj.mountImage(WoodLongBowBackImage,1);%obj.unhideNode("ALL");
	if(isObject(%obj.client))
	{%obj.client.applyBodyParts();%obj.client.applyBodyColors();}
	else{applyDefaultCharacterPrefs(%obj);}
	%obj.client.setControlCameraFov(90);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////
function WoodLongBowimage::onFire(%this,%obj,%slot,%spread,%shellcount,%recoil)
{
	if(%obj.toolAmmo[%obj.currTool] > 1)
	{
		%obj.toolAmmo[%obj.currTool] = 1;
	}

	if(%obj.toolAmmo[%obj.currTool] > 0 && %obj.isImageMounted(WoodLongBowImage))
	{
		%projectile = WoodLongBowRegProjectile;%spread = 0.000;%shellcount = 1;%obj.toolAmmo[%obj.currTool]--;%obj.AmmoSpent[%obj.currTool]++;
        	commandToClient(%obj.client,'bottomPrint',"<just:right><color:ffffff>RegArrows: \c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["CpArr"] @ "", 1, 2, 3, 4); 
		for(%shell=0; %shell<%shellcount; %shell++)
		{%vector = %obj.getMuzzleVector(%slot);%objectVelocity = %obj.getVelocity();%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);%velocity = VectorAdd(%vector1,%vector2);%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);%velocity = MatrixMulVector(%mat, %velocity);
			%p = new (%this.projectileType)()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};
			MissionCleanup.add(%p);
		}
		return %p;
	}
    	if(%obj.client.quantity["CpArr"] < 1){%obj.client.quantity["CpArr"] = 0;}
}
function WoodLongBowFireimage::onFire(%this,%obj,%slot,%spread,%shellcount,%recoil)
{
	if(%obj.toolAmmo[%obj.currTool] > 1)
	{
		%obj.toolAmmo[%obj.currTool] = 1;
	}

	if(%obj.toolAmmo[%obj.currTool] > 0 && %obj.isImageMounted(WoodLongBowFireImage))
	{
		%projectile = WoodLongBowFireProjectile;%spread = 0.000;%shellcount = 1;%obj.toolAmmo[%obj.currTool]--;%obj.AmmoSpent[%obj.currTool]++;
        	commandToClient(%obj.client,'bottomPrint',"<just:right><color:ffffff>FireArrows: \c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["FireArr"] @ "", 1, 2, 3, 4); 
		for(%shell=0; %shell<%shellcount; %shell++)
		{%vector = %obj.getMuzzleVector(%slot);%objectVelocity = %obj.getVelocity();%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);%velocity = VectorAdd(%vector1,%vector2);%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);%velocity = MatrixMulVector(%mat, %velocity);
			%p = new (%this.projectileType)()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};
			MissionCleanup.add(%p);
		}
		return %p;
	}
	if(%obj.client.quantity["FireArr"] < 1){%obj.client.quantity["FireArr"] = 0;}
}
function WoodLongBowIceimage::onFire(%this,%obj,%slot,%spread,%shellcount,%recoil)
{
	if(%obj.toolAmmo[%obj.currTool] > 1)
	{
		%obj.toolAmmo[%obj.currTool] = 1;
	}

	if(%obj.toolAmmo[%obj.currTool] > 0 && %obj.isImageMounted(WoodLongBowIceImage))
	{
		%projectile = WoodLongBowIceProjectile;%spread = 0.000;%shellcount = 1;%obj.toolAmmo[%obj.currTool]--;%obj.AmmoSpent[%obj.currTool]++;
        	commandToClient(%obj.client,'bottomPrint',"<just:right><color:ffffff>IceArrows: \c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["IceArr"] @ "", 1, 2, 3, 4); 
		for(%shell=0; %shell<%shellcount; %shell++)
		{%vector = %obj.getMuzzleVector(%slot);%objectVelocity = %obj.getVelocity();%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);%velocity = VectorAdd(%vector1,%vector2);%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);%velocity = MatrixMulVector(%mat, %velocity);
			%p = new (%this.projectileType)()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};
			MissionCleanup.add(%p);
		}
		return %p;
	}

	if(%obj.client.quantity["IceArr"] < 1){%obj.client.quantity["IceArr"] = 0;}
}
function WoodLongBowExpimage::onFire(%this,%obj,%slot,%spread,%shellcount,%recoil)
{
	if(%obj.toolAmmo[%obj.currTool] > 1)
	{
		%obj.toolAmmo[%obj.currTool] = 1;
	}

	if(%obj.toolAmmo[%obj.currTool] > 0 && %obj.isImageMounted(WoodLongBowExpImage))
	{
		%projectile = WoodLongBowExpProjectile;%spread = 0.000;%shellcount = 1;%obj.toolAmmo[%obj.currTool]--;%obj.AmmoSpent[%obj.currTool]++;
        	commandToClient(%obj.client,'bottomPrint',"<just:right><color:ffffff>ExpArrows: \c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["ExpArr"] @ "", 1, 2, 3, 4); 
		for(%shell=0; %shell<%shellcount; %shell++)
		{%vector = %obj.getMuzzleVector(%slot);%objectVelocity = %obj.getVelocity();%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);%velocity = VectorAdd(%vector1,%vector2);%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);%velocity = MatrixMulVector(%mat, %velocity);
			%p = new (%this.projectileType)()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};
			MissionCleanup.add(%p);
		}
		return %p;
	}
	if(%obj.client.quantity["ExpArr"] < 1){%obj.client.quantity["ExpArr"] = 0;}
}

package WoodLongBowDropPackage
{
  function servercmdDropTool(%this,%slot)
  {
	parent::servercmdDropTool(%this,%slot);
	%this.player.schedule(5,unmountimage,1);
	%this.player.schedule(5,unmountimage,0);
  }
};
activatePackage(WoodLongBowDropPackage);
function WoodLongBowRegProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)

{parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);

	if(%col.getClassName() $= "fxDTSBrick")

	{$InputTarget_["Self"] = %col;$InputTarget_["Player"] = %obj.client.player;$InputTarget_["Client"] = %obj.client;

		if($Server::LAN)
{
$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj.client);
}

		else
{
if(getMiniGameFromObject(%col) == getMiniGameFromObject(%obj.client))
{
$InputTarget_["MiniGame"] = getMiniGameFromObject(%col);
}

			else
{
$InputTarget_["MiniGame"] = 0;
}
}
%col.processInputEvent(OnBowRegHit,%obj.client);
}

}
function WoodLongBowFireProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)

{parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);

	if(%col.getClassName() $= "fxDTSBrick")

	{$InputTarget_["Self"] = %col;$InputTarget_["Player"] = %obj.client.player;$InputTarget_["Client"] = %obj.client;

		if($Server::LAN)
{
$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj.client);
}

		else
{
if(getMiniGameFromObject(%col) == getMiniGameFromObject(%obj.client))
{
$InputTarget_["MiniGame"] = getMiniGameFromObject(%col);
}

			else
{
$InputTarget_["MiniGame"] = 0;
}
}
%col.processInputEvent(OnBowFireHit,%obj.client);
}

}
function WoodLongBowIceProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)

{parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);

	if(%col.getClassName() $= "fxDTSBrick")

	{$InputTarget_["Self"] = %col;$InputTarget_["Player"] = %obj.client.player;$InputTarget_["Client"] = %obj.client;

		if($Server::LAN)
{
$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj.client);
}

		else
{
if(getMiniGameFromObject(%col) == getMiniGameFromObject(%obj.client))
{
$InputTarget_["MiniGame"] = getMiniGameFromObject(%col);
}

			else
{
$InputTarget_["MiniGame"] = 0;
}
}
%col.processInputEvent(OnBowIceHit,%obj.client);
}

}
function WoodLongBowExpProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)

{parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);

	if(%col.getClassName() $= "fxDTSBrick")

	{$InputTarget_["Self"] = %col;$InputTarget_["Player"] = %obj.client.player;$InputTarget_["Client"] = %obj.client;

		if($Server::LAN)
{
$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj.client);
}

		else
{
if(getMiniGameFromObject(%col) == getMiniGameFromObject(%obj.client))
{
$InputTarget_["MiniGame"] = getMiniGameFromObject(%col);
}

			else
{
$InputTarget_["MiniGame"] = 0;
}
}
%col.processInputEvent(OnBowExpHit,%obj.client);
}

}